# Amp: Atomistic Machine-learning Package #


*Amp* is an open-source package designed to easily bring machine-learning to atomistic calculations. This project is being developed at Brown University in the School of Engineering, primarily by Andrew Peterson and Alireza Khorshidi, and is released under the GNU General Public License.  *Amp* allows for the modular representation of the potential energy surface, enabling the user to specify or create descriptor and regression methods.

This project lives at:
https://bitbucket.org/andrewpeterson/amp

Documentation lives at:
http://amp.readthedocs.org

Users' mailing list lives at:
https://listserv.brown.edu/?A0=AMP-USERS
(Subscribe page:)
https://listserv.brown.edu/?SUBED1=AMP-USERS&A=1

If you would like to compile a local version of the documentation, see the README file in the docs directory.


License
=======

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.


Installation
============

You can find the installation instructions for this version of Amp in the
documentation file `docs/installation.rst`.

Documentation
=============

We currently host multiple versions of the documentation, which includes
installation instructions, at http://amp.readthedocs.io. 

You can build a local copy of the documentation for this version of Amp.
You will find instructions to do this in the "Documentation" section of the
file `docs/develop.rst`.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     module that utilizes the regression model to calculate energies
!     and forces as well as their derivatives. Function names ending
!     with an underscore correspond to image-centered mode.

      module neuralnetwork
      implicit none

!     the data of neuralnetwork (should be fed in by python)
      double precision, allocatable::min_fingerprints(:, :)
      double precision, allocatable::max_fingerprints(:, :)
      integer, allocatable:: no_layers_of_elements(:)
      integer, allocatable:: no_nodes_of_elements(:)
      integer:: activation_signal

      type:: real_two_d_array
        sequence
        double precision, allocatable:: twodarray(:,:)
      end type real_two_d_array

      type:: element_parameters
        sequence
        double precision:: intercept
        double precision:: slope
        type(real_two_d_array), allocatable:: weights(:)
      end type element_parameters

      type:: real_one_d_array
        sequence
        double precision, allocatable:: onedarray(:)
      end type real_one_d_array

      contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     Returns energy value in the image-centered mode.
      function calculate_image_energy(num_inputs, inputs, num_parameters, &
      parameters)
      implicit none

      integer:: num_inputs, num_parameters
      double precision:: inputs(num_inputs)
      double precision:: parameters(num_parameters)
      double precision:: calculate_image_energy

      integer:: p, m, n, layer
      integer:: l, j, num_rows, num_cols, q
      integer, allocatable:: hiddensizes(:)
      double precision, allocatable:: net(:)
      type(real_one_d_array), allocatable:: o(:), ohat(:)
      type(real_two_d_array), allocatable:: weights(:)
      double precision:: intercept
      double precision:: slope

!     changing the form of parameters from vector into derived-types
      l = 0
      allocate(weights(no_layers_of_elements(1)-1))
      do j = 1, no_layers_of_elements(1) - 1
          num_rows = no_nodes_of_elements(j) + 1
          num_cols = no_nodes_of_elements(j + 1)
          allocate(weights(j)%twodarray(num_rows, num_cols))
          do p = 1, num_rows
              do q = 1, num_cols
                  weights(j)%twodarray(p, q) = &
                  parameters(l + (p - 1) * num_cols + q)
              end do
          end do
          l = l + num_rows * num_cols
      end do
      intercept = parameters(l + 1)
      slope = parameters(l + 2)

      allocate(hiddensizes(no_layers_of_elements(1) - 2))
      do m = 1, no_layers_of_elements(1) - 2
          hiddensizes(m) = no_nodes_of_elements(m + 1)
      end do

      allocate(o(no_layers_of_elements(1)))
      allocate(ohat(no_layers_of_elements(1)))
      layer = 1
      allocate(o(1)%onedarray(num_inputs))
      allocate(ohat(1)%onedarray(num_inputs + 1))
      do m = 1, num_inputs
          o(1)%onedarray(m) = inputs(m)
      end do
      do layer = 1, size(hiddensizes) + 1
          do m = 1, size(weights(layer)%twodarray, dim=1) - 1
              ohat(layer)%onedarray(m) = o(layer)%onedarray(m)
          end do
          ohat(layer)%onedarray(&
          size(weights(layer)%twodarray, dim=1)) = 1.0d0
          allocate(net(size(weights(layer)%twodarray, dim=2)))
          allocate(o(layer + 1)%onedarray(&
          size(weights(layer)%twodarray, dim=2)))
          allocate(ohat(layer + 1)%onedarray(&
          size(weights(layer)%twodarray, dim=2) + 1))
          do m = 1, size(weights(layer)%twodarray, dim=2)
              net(m) = 0.0d0
              do n = 1, size(weights(layer)%twodarray, dim=1)
                  net(m) =  net(m) + &
                  ohat(layer)%onedarray(n) &
                  * weights(layer)%twodarray(n, m)
              end do
              if (activation_signal == 1) then
                  o(layer + 1)%onedarray(m) = &
                  tanh(net(m))
              else if (activation_signal == 2) then
                  o(layer + 1)%onedarray(m) = &
                  1.0d0 / (1.0d0 +  exp(- net(m)))
              else if (activation_signal == 3) then
                  o(layer + 1)%onedarray(m) = net(m)
              end if
              ohat(layer + 1)%onedarray(m) = o(layer + 1)%onedarray(m)
          end do
          ohat(layer + 1)%onedarray(&
          size(weights(layer)%twodarray, dim=2) + 1) =  1.0d0
          deallocate(net)
      end do

      calculate_image_energy = slope * o(layer)%onedarray(1) + intercept

!     deallocating neural network
      deallocate(hiddensizes)
      do p = 1, size(o)
          deallocate(o(p)%onedarray)
      end do
      deallocate(o)
      do p = 1, size(ohat)
          deallocate(ohat(p)%onedarray)
      end do
      deallocate(ohat)

!     deallocating derived type parameters
      do p = 1, size(weights)
          deallocate(weights(p)%twodarray)
      end do
      deallocate(weights)

      end function calculate_image_energy

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     Returns energy value in the atom-centered mode.
      function calculate_atomic_energy(symbol, &
      len_of_fingerprint, fingerprint, &
      num_elements, elements_numbers, &
      num_parameters, parameters)
      implicit none

      integer:: symbol, num_parameters, &
      len_of_fingerprint, num_elements
      double precision:: fingerprint(len_of_fingerprint)
      integer:: elements_numbers(num_elements)
      double precision:: parameters(num_parameters)
      double precision:: calculate_atomic_energy

      integer:: p, element, m, n, layer
      integer:: k, l, j, num_rows, num_cols, q
      integer, allocatable:: hiddensizes(:)
      double precision, allocatable:: net(:)
      type(real_one_d_array), allocatable:: o(:), ohat(:)
      type(element_parameters):: unraveled_parameters(num_elements)
      double precision:: fingerprint_(len_of_fingerprint)

      ! scaling fingerprints
      do element = 1, num_elements
        if (symbol == &
            elements_numbers(element)) then
            exit
        end if
      end do
      do l = 1, len_of_fingerprint
        if ((max_fingerprints(element, l) - &
        min_fingerprints(element, l)) .GT. &
        (10.0d0 ** (-8.0d0))) then
            fingerprint_(l) = -1.0d0 + 2.0d0 * &
            (fingerprint(l) - min_fingerprints(element, l)) / &
            (max_fingerprints(element, l) - &
            min_fingerprints(element, l))
        else
            fingerprint_(l) = fingerprint(l)
        endif
      end do

!     changing the form of parameters from vector into derived-types
      k = 0
      l = 0
      do element = 1, num_elements
        allocate(unraveled_parameters(element)%weights(&
        no_layers_of_elements(element)-1))
        if (element .GT. 1) then
            k = k + no_layers_of_elements(element - 1)
        end if
        do j = 1, no_layers_of_elements(element) - 1
            num_rows = no_nodes_of_elements(k + j) + 1
            num_cols = no_nodes_of_elements(k + j + 1)
            allocate(unraveled_parameters(&
            element)%weights(j)%twodarray(num_rows, num_cols))
            do p = 1, num_rows
                do q = 1, num_cols
                    unraveled_parameters(element)%weights(j)%twodarray(&
                    p, q) = parameters(l + (p - 1) * num_cols + q)
                end do
            end do
            l = l + num_rows * num_cols
        end do
      end do
      do element = 1, num_elements
        unraveled_parameters(element)%intercept = &
        parameters(l + 2 *  element - 1)
        unraveled_parameters(element)%slope = &
        parameters(l + 2 * element)
      end do

      p = 0
      do element = 1, num_elements
          if (symbol == elements_numbers(element)) then
              exit
          else
              p = p + no_layers_of_elements(element)
          end if
      end do
      allocate(hiddensizes(no_layers_of_elements(element) - 2))
      do m = 1, no_layers_of_elements(element) - 2
          hiddensizes(m) = no_nodes_of_elements(p + m + 1)
      end do

      allocate(o(no_layers_of_elements(element)))
      allocate(ohat(no_layers_of_elements(element)))
      layer = 1
      allocate(o(1)%onedarray(len_of_fingerprint))
      allocate(ohat(1)%onedarray(len_of_fingerprint + 1))
      do m = 1, len_of_fingerprint
          o(1)%onedarray(m) = fingerprint_(m)
      end do
      do layer = 1, size(hiddensizes) + 1
          do m = 1, size(unraveled_parameters(element)%weights(&
          layer)%twodarray, dim=1) - 1
              ohat(layer)%onedarray(m) = o(layer)%onedarray(m)
          end do
          ohat(layer)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=1)) = 1.0d0
          allocate(net(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2)))
          allocate(o(layer + 1)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2)))
          allocate(ohat(layer + 1)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2) + 1))
          do m = 1, size(unraveled_parameters(element)%weights(&
          layer)%twodarray, dim=2)
              net(m) = 0.0d0
              do n = 1, size(unraveled_parameters(element)%weights(&
              layer)%twodarray, dim=1)
                  net(m) =  net(m) + &
                  ohat(layer)%onedarray(n) * unraveled_parameters(&
                  element)%weights(layer)%twodarray(n, m)
              end do
              if (activation_signal == 1) then
                  o(layer + 1)%onedarray(m) = tanh(net(m))
              else if (activation_signal == 2) then
                  o(layer + 1)%onedarray(m) = &
                  1.0d0 / (1.0d0 +  exp(- net(m)))
              else if (activation_signal == 3) then
                  o(layer + 1)%onedarray(m) = net(m)
              end if
              ohat(layer + 1)%onedarray(m) = o(layer + 1)%onedarray(m)
          end do
          ohat(layer + 1)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2) + 1) =  1.0d0
          deallocate(net)
      end do

      calculate_atomic_energy = unraveled_parameters(element)%slope * &
      o(layer)%onedarray(1) + unraveled_parameters(element)%intercept

!     deallocating neural network
      deallocate(hiddensizes)
      do p = 1, size(o)
          deallocate(o(p)%onedarray)
      end do
      deallocate(o)
      do p = 1, size(ohat)
          deallocate(ohat(p)%onedarray)
      end do
      deallocate(ohat)

!      deallocating derived-type parameters
      k = 0
      do element = 1, num_elements
        if (element .GT. 1) then
          k = k + no_layers_of_elements(element - 1)
        end if
        do j = 1, no_layers_of_elements(element) - 1
          num_rows = no_nodes_of_elements(k + j) + 1
          num_cols = no_nodes_of_elements(k + j + 1)
          deallocate(unraveled_parameters(&
          element)%weights(j)%twodarray)
        end do
        deallocate(unraveled_parameters(element)%weights)
      end do

      end function calculate_atomic_energy

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     Returns force value in the image-centered mode.
      function calculate_force_(num_inputs, inputs, inputs_, &
      num_parameters, parameters)
      implicit none

      integer:: num_inputs, num_parameters
      double precision:: inputs(num_inputs)
      double precision:: inputs_(num_inputs)
      double precision:: parameters(num_parameters)
      double precision:: calculate_force_

      double precision, allocatable:: temp(:)
      integer:: p, q, m, n, nn, layer
      integer:: l, j, num_rows, num_cols
      integer, allocatable:: hiddensizes(:)
      double precision, allocatable:: net(:)
      type(real_one_d_array), allocatable:: o(:), ohat(:)
      type(real_one_d_array), allocatable:: doutputs_dinputs(:)
      type(real_two_d_array), allocatable:: weights(:)
      double precision:: intercept
      double precision:: slope

!     changing the form of parameters to derived-types
      l = 0
      allocate(weights(no_layers_of_elements(1)-1))
      do j = 1, no_layers_of_elements(1) - 1
          num_rows = no_nodes_of_elements(j) + 1
          num_cols = no_nodes_of_elements(j + 1)
          allocate(weights(j)%twodarray(num_rows, num_cols))
          do p = 1, num_rows
              do q = 1, num_cols
                  weights(j)%twodarray(p, q) = &
                  parameters(l + (p - 1) * num_cols + q)
              end do
          end do
          l = l + num_rows * num_cols
      end do

      intercept = parameters(l + 1)
      slope = parameters(l + 2)

      allocate(hiddensizes(no_layers_of_elements(1) - 2))
      do m = 1, no_layers_of_elements(1) - 2
          hiddensizes(m) = no_nodes_of_elements(m + 1)
      end do
      allocate(o(no_layers_of_elements(1)))
      allocate(ohat(no_layers_of_elements(1)))
      layer = 1
      allocate(o(1)%onedarray(num_inputs))
      allocate(ohat(1)%onedarray(num_inputs + 1))
      do m = 1, num_inputs
          o(1)%onedarray(m) = inputs(m)
      end do
      do layer = 1, size(hiddensizes) + 1
          do m = 1, size(weights(layer)%twodarray, dim=1) - 1
              ohat(layer)%onedarray(m) = o(layer)%onedarray(m)
          end do
          ohat(layer)%onedarray(&
          size(weights(layer)%twodarray, dim=1)) = 1.0d0
          allocate(net(size(weights(layer)%twodarray, dim=2)))
          allocate(o(layer + 1)%onedarray(&
          size(weights(layer)%twodarray, dim=2)))
          allocate(ohat(layer + 1)%onedarray(&
          size(weights(layer)%twodarray, dim=2) + 1))
          do m = 1, size(weights(layer)%twodarray, dim=2)
              net(m) = 0.0d0
              do n = 1, size(weights(layer)%twodarray, dim=1)
                  net(m) =  net(m) + &
                  ohat(layer)%onedarray(n) * &
                  weights(layer)%twodarray(n, m)
              end do
              if (activation_signal == 1) then
                  o(layer + 1)%onedarray(m) = tanh(net(m))
              else if (activation_signal == 2) then
                  o(layer + 1)%onedarray(m) = &
                  1.0d0 / (1.0d0 +  exp(- net(m)))
              else if (activation_signal == 3) then
                  o(layer + 1)%onedarray(m) = net(m)
              end if
              ohat(layer + 1)%onedarray(m) = o(layer + 1)%onedarray(m)
          end do
          deallocate(net)
      end do
      nn = size(o) - 2
      allocate(doutputs_dinputs(nn + 2))
      allocate(doutputs_dinputs(1)%onedarray(num_inputs))
      do m = 1, num_inputs
      doutputs_dinputs(1)%onedarray(m) = inputs_(m)
      end do
      do layer = 1, nn + 1
          allocate(temp(size(weights(layer)%twodarray, dim = 2)))
          do p = 1, size(weights(layer)%twodarray, dim = 2)
              temp(p) = 0.0d0
              do q = 1, size(weights(layer)%twodarray, dim = 1) - 1
                  temp(p) = temp(p) + doutputs_dinputs(&
                  layer)%onedarray(q) * weights(layer)%twodarray(q, p)
              end do
          end do
          q = size(o(layer + 1)%onedarray)
          allocate(doutputs_dinputs(layer + 1)%onedarray(q))
          do p = 1, size(o(layer + 1)%onedarray)
              if (activation_signal == 1) then
                doutputs_dinputs(layer + 1)%onedarray(p) = &
                temp(p) * (1.0d0 - o(layer + 1)%onedarray(p) * &
                o(layer + 1)%onedarray(p))
              else if (activation_signal == 2) then
                doutputs_dinputs(layer + 1)%onedarray(p) = &
                temp(p) * (1.0d0 - o(layer + 1)%onedarray(p)) * &
                o(layer + 1)%onedarray(p)
              else if (activation_signal == 3) then
                doutputs_dinputs(layer+ 1)%onedarray(p) = temp(p)
              end if
          end do
          deallocate(temp)
      end do

      calculate_force_ = slope * doutputs_dinputs(nn + 2)%onedarray(1)
      ! force is multiplied by -1, because it is -dE/dx and not dE/dx.
      calculate_force_ = -1.0d0 * calculate_force_
!     deallocating neural network
      deallocate(hiddensizes)
      do p = 1, size(o)
          deallocate(o(p)%onedarray)
      end do
      deallocate(o)
      do p = 1, size(ohat)
          deallocate(ohat(p)%onedarray)
      end do
      deallocate(ohat)
      do p = 1, size(doutputs_dinputs)
          deallocate(doutputs_dinputs(p)%onedarray)
      end do
      deallocate(doutputs_dinputs)

!     deallocating derived type parameters
      do p = 1, size(weights)
          deallocate(weights(p)%twodarray)
      end do
      deallocate(weights)

      end function calculate_force_

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     Returns force value in the atom-centered mode.
      function calculate_force(symbol, len_of_fingerprint, fingerprint, &
      fingerprintprime, num_elements, elements_numbers, &
      num_parameters, parameters)
      implicit none

      integer:: symbol, len_of_fingerprint, num_parameters
      integer:: num_elements
      double precision:: fingerprint(len_of_fingerprint)
      double precision:: fingerprintprime(len_of_fingerprint)
      integer:: elements_numbers(num_elements)
      double precision:: parameters(num_parameters)
      double precision:: calculate_force

      double precision, allocatable:: temp(:)
      integer:: p, q, element, m, n, nn, layer
      integer:: k, l, j, num_rows, num_cols
      integer, allocatable:: hiddensizes(:)
      double precision, allocatable:: net(:)
      type(real_one_d_array), allocatable:: o(:), ohat(:)
      type(real_one_d_array), allocatable:: doutputs_dinputs(:)
      type(element_parameters):: unraveled_parameters(num_elements)
      double precision:: fingerprint_(len_of_fingerprint)
      double precision:: fingerprintprime_(len_of_fingerprint)

      ! scaling fingerprints
      do element = 1, num_elements
        if (symbol == &
            elements_numbers(element)) then
            exit
        end if
      end do
      do l = 1, len_of_fingerprint
        if ((max_fingerprints(element, l) - &
        min_fingerprints(element, l)) .GT. &
        (10.0d0 ** (-8.0d0))) then
            fingerprint_(l) = -1.0d0 + 2.0d0 * &
            (fingerprint(l) - min_fingerprints(element, l)) / &
            (max_fingerprints(element, l) - &
            min_fingerprints(element, l))
        else
            fingerprint_(l) = fingerprint(l)
        endif
      end do
      ! scaling fingerprintprimes
      do l = 1, len_of_fingerprint
        if ((max_fingerprints(element, l) - &
        min_fingerprints(element, l)) .GT. &
        (10.0d0 ** (-8.0d0))) then
            fingerprintprime_(l) = &
            2.0d0 * fingerprintprime(l) / &
            (max_fingerprints(element, l) - &
            min_fingerprints(element, l))
        else
            fingerprintprime_(l) = fingerprintprime(l)
        endif
      end do

!     changing the form of parameters to derived-types
      k = 0
      l = 0
      do element = 1, num_elements
        allocate(unraveled_parameters(element)%weights(&
        no_layers_of_elements(element)-1))
        if (element .GT. 1) then
            k = k + no_layers_of_elements(element - 1)
        end if
        do j = 1, no_layers_of_elements(element) - 1
            num_rows = no_nodes_of_elements(k + j) + 1
            num_cols = no_nodes_of_elements(k + j + 1)
            allocate(unraveled_parameters(&
            element)%weights(j)%twodarray(num_rows, num_cols))
            do p = 1, num_rows
                do q = 1, num_cols
                    unraveled_parameters(element)%weights(j)%twodarray(&
                    p, q) = parameters(l + (p - 1) * num_cols + q)
                end do
            end do
            l = l + num_rows * num_cols
        end do
      end do
      do element = 1, num_elements
        unraveled_parameters(element)%intercept = &
        parameters(l + 2 *  element - 1)
        unraveled_parameters(element)%slope = &
        parameters(l + 2 * element)
      end do

      p = 0
      do element = 1, num_elements
          if (symbol == elements_numbers(element)) then
              exit
          else
              p = p + no_layers_of_elements(element)
          end if
      end do

      allocate(hiddensizes(no_layers_of_elements(element) - 2))
      do m = 1, no_layers_of_elements(element) - 2
          hiddensizes(m) = no_nodes_of_elements(p + m + 1)
      end do
      allocate(o(no_layers_of_elements(element)))
      allocate(ohat(no_layers_of_elements(element)))
      layer = 1
      allocate(o(1)%onedarray(len_of_fingerprint))
      allocate(ohat(1)%onedarray(len_of_fingerprint + 1))
      do m = 1, len_of_fingerprint
          o(1)%onedarray(m) = fingerprint_(m)
      end do
      do layer = 1, size(hiddensizes) + 1
          do m = 1, size(unraveled_parameters(element)%weights(&
          layer)%twodarray, dim=1) - 1
              ohat(layer)%onedarray(m) = o(layer)%onedarray(m)
          end do
          ohat(layer)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=1)) = 1.0d0
          allocate(net(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2)))
          allocate(o(layer + 1)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2)))
          allocate(ohat(layer + 1)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2) + 1))
          do m = 1, size(unraveled_parameters(element)%weights(&
          layer)%twodarray, dim=2)
              net(m) = 0.0d0
              do n = 1, size(unraveled_parameters(element)%weights(&
              layer)%twodarray, dim=1)
                  net(m) =  net(m) + &
                  ohat(layer)%onedarray(n) * unraveled_parameters(&
                  element)%weights(layer)%twodarray(n, m)
              end do
              if (activation_signal == 1) then
                  o(layer + 1)%onedarray(m) = tanh(net(m))
              else if (activation_signal == 2) then
                  o(layer + 1)%onedarray(m) = &
                  1.0d0 / (1.0d0 +  exp(- net(m)))
              else if (activation_signal == 3) then
                  o(layer + 1)%onedarray(m) = net(m)
              end if
              ohat(layer + 1)%onedarray(m) = o(layer + 1)%onedarray(m)
          end do
          deallocate(net)
      end do
      nn = size(o) - 2
      allocate(doutputs_dinputs(nn + 2))
      allocate(doutputs_dinputs(1)%onedarray(&
      len_of_fingerprint))
      do m = 1, len_of_fingerprint
      doutputs_dinputs(1)%onedarray(m) = fingerprintprime_(m)
      end do
      do layer = 1, nn + 1
          allocate(temp(size(unraveled_parameters(element)%weights(&
          layer)%twodarray, dim = 2)))
          do p = 1, size(unraveled_parameters(element)%weights(&
          layer)%twodarray, dim = 2)
              temp(p) = 0.0d0
              do q = 1, size(unraveled_parameters(element)%weights(&
              layer)%twodarray, dim = 1) - 1
                  temp(p) = temp(p) + doutputs_dinputs(&
                  layer)%onedarray(q) * unraveled_parameters(&
                  element)%weights(layer)%twodarray(q, p)
              end do
          end do
          q = size(o(layer + 1)%onedarray)
          allocate(doutputs_dinputs(layer + 1)%onedarray(q))
          do p = 1, size(o(layer + 1)%onedarray)
              if (activation_signal == 1) then
                doutputs_dinputs(layer + 1)%onedarray(p) = temp(p) * &
                (1.0d0 - o(layer + 1)%onedarray(p) * &
                o(layer + 1)%onedarray(p))
              else if (activation_signal == 2) then
                doutputs_dinputs(layer + 1)%onedarray(p) = &
                temp(p) * (1.0d0 - o(layer + 1)%onedarray(p)) * &
                o(layer + 1)%onedarray(p)
              else if (activation_signal == 3) then
                doutputs_dinputs(layer+ 1)%onedarray(p) = temp(p)
              end if
          end do
          deallocate(temp)
      end do

      calculate_force = unraveled_parameters(element)%slope * &
      doutputs_dinputs(nn + 2)%onedarray(1)
      ! force is multiplied by -1, because it is -dE/dx and not dE/dx.
      calculate_force = -1.0d0 * calculate_force
!     deallocating neural network
      deallocate(hiddensizes)
      do p = 1, size(o)
          deallocate(o(p)%onedarray)
      end do
      deallocate(o)
      do p = 1, size(ohat)
          deallocate(ohat(p)%onedarray)
      end do
      deallocate(ohat)
      do p = 1, size(doutputs_dinputs)
          deallocate(doutputs_dinputs(p)%onedarray)
      end do
      deallocate(doutputs_dinputs)

!     deallocating derived-type parameters
      k = 0
      do element = 1, num_elements
        if (element .GT. 1) then
          k = k + no_layers_of_elements(element - 1)
        end if
        do j = 1, no_layers_of_elements(element) - 1
          num_rows = no_nodes_of_elements(k + j) + 1
          num_cols = no_nodes_of_elements(k + j + 1)
          deallocate(unraveled_parameters(&
          element)%weights(j)%twodarray)
        end do
        deallocate(unraveled_parameters(element)%weights)
      end do

      end function calculate_force

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     Returns derivative of energy w.r.t. parameters in the
!     image-centered mode.
      function calculate_denergy_dparameters_(num_inputs, inputs, &
      num_parameters, parameters)
      implicit none

      integer:: num_inputs, num_parameters
      double precision:: calculate_denergy_dparameters_(num_parameters)
      double precision:: parameters(num_parameters)
      double precision:: inputs(num_inputs)

      integer:: m, n, j, l, layer, p, q, nn, num_cols, num_rows
      double precision:: temp1, temp2
      integer, allocatable:: hiddensizes(:)
      double precision, allocatable:: net(:)
      type(real_one_d_array), allocatable:: o(:), ohat(:)
      type(real_one_d_array), allocatable:: delta(:), D(:)
      type(real_two_d_array), allocatable:: weights(:)
      double precision:: intercept
      double precision:: slope
      type(real_two_d_array), allocatable:: &
      unraveled_denergy_dweights(:)
      double precision:: denergy_dintercept
      double precision:: denergy_dslope

!     changing the form of parameters from vector into derived-types
      l = 0
      allocate(weights(no_layers_of_elements(1)-1))
      do j = 1, no_layers_of_elements(1) - 1
          num_rows = no_nodes_of_elements(j) + 1
          num_cols = no_nodes_of_elements(j + 1)
          allocate(weights(j)%twodarray(num_rows, num_cols))
          do p = 1, num_rows
              do q = 1, num_cols
                  weights(j)%twodarray(p, q) = &
                  parameters(l + (p - 1) * num_cols + q)
              end do
          end do
          l = l + num_rows * num_cols
      end do
      intercept = parameters(l + 1)
      slope = parameters(l + 2)

      denergy_dintercept = 0.d0
      denergy_dslope = 0.d0
      l = 0
      allocate(unraveled_denergy_dweights(no_layers_of_elements(1)-1))
      do j = 1, no_layers_of_elements(1) - 1
          num_rows = no_nodes_of_elements(j) + 1
          num_cols = no_nodes_of_elements(j + 1)
          allocate(unraveled_denergy_dweights(j)%twodarray(num_rows, &
          num_cols))
          do p = 1, num_rows
              do q = 1, num_cols
                  unraveled_denergy_dweights(j)%twodarray(p, q) = 0.0d0
              end do
          end do
          l = l + num_rows * num_cols
      end do

      allocate(hiddensizes(no_layers_of_elements(1) - 2))
      do m = 1, no_layers_of_elements(1) - 2
          hiddensizes(m) = no_nodes_of_elements(m + 1)
      end do
      allocate(o(no_layers_of_elements(1)))
      allocate(ohat(no_layers_of_elements(1)))
      layer = 1
      allocate(o(1)%onedarray(num_inputs))
      allocate(ohat(1)%onedarray(num_inputs + 1))
      do m = 1, num_inputs
          o(1)%onedarray(m) = inputs(m)
      end do
      do layer = 1, size(hiddensizes) + 1
          do m = 1, size(weights(layer)%twodarray, dim=1) - 1
              ohat(layer)%onedarray(m) = o(layer)%onedarray(m)
          end do
          ohat(layer)%onedarray(&
          size(weights(layer)%twodarray, dim=1)) = 1.0d0
          allocate(net(size(weights(layer)%twodarray, dim=2)))
          allocate(o(layer + 1)%onedarray(&
          size(weights(layer)%twodarray, dim=2)))
          allocate(ohat(layer + 1)%onedarray(&
          size(weights(layer)%twodarray, dim=2) + 1))
          do m = 1, size(weights(layer)%twodarray, dim=2)
              net(m) = 0.0d0
              do n = 1, size(weights(layer)%twodarray, dim=1)
                  net(m) =  net(m) + &
                  ohat(layer)%onedarray(n) * weights(&
                  layer)%twodarray(n, m)
              end do
              if (activation_signal == 1) then
                  o(layer + 1)%onedarray(m) = tanh(net(m))
              else if (activation_signal == 2) then
                  o(layer + 1)%onedarray(m) = &
                  1.0d0 / (1.0d0 +  exp(- net(m)))
              else if (activation_signal == 3) then
                  o(layer + 1)%onedarray(m) = net(m)
              end if
              ohat(layer + 1)%onedarray(m) = o(layer + 1)%onedarray(m)
          end do
          ohat(layer + 1)%onedarray(&
          size(weights(layer)%twodarray, dim=2) + 1) =  1.0d0
          deallocate(net)
      end do

      nn = size(o) - 2
      allocate(D(nn + 1))
      do layer = 1, nn + 1
          allocate(D(layer)%onedarray(size(o(layer + 1)%onedarray)))
          do j = 1, size(o(layer + 1)%onedarray)
              if (activation_signal == 1) then
                  D(layer)%onedarray(j) = &
                  (1.0d0 - o(layer + 1)%onedarray(j)* &
                  o(layer + 1)%onedarray(j))
              elseif (activation_signal == 2) then
                  D(layer)%onedarray(j) = o(layer + 1)%onedarray(j) * &
                  (1.0d0 - o(layer + 1)%onedarray(j))
              elseif (activation_signal == 3) then
                  D(layer)%onedarray(j) = 1.0d0
              end if
          end do
      end do
      allocate(delta(nn + 1))
      allocate(delta(nn + 1)%onedarray(1))
      delta(nn + 1)%onedarray(1) = D(nn + 1)%onedarray(1)
      do layer = nn, 1, -1
          allocate(delta(layer)%onedarray(size(D(layer)%onedarray)))
          do p = 1, size(D(layer)%onedarray)
              delta(layer)%onedarray(p) = 0.0d0
              do q = 1, size(delta(layer + 1)%onedarray)
                  temp1 = D(layer)%onedarray(p) * &
                  weights(layer + 1)%twodarray(p, q)
                  temp2 = temp1  * delta(layer + 1)%onedarray(q)
                  delta(layer)%onedarray(p) = &
                  delta(layer)%onedarray(p) + temp2
              end do
          end do
      end do

      denergy_dintercept = 1.0d0
      denergy_dslope = o(nn + 2)%onedarray(1)
      do layer = 1, nn + 1
          do p = 1, size(ohat(layer)%onedarray)
              do q = 1, size(delta(layer)%onedarray)
                  unraveled_denergy_dweights(layer)%twodarray(p, q) = &
                  slope * &
                  ohat(layer)%onedarray(p) * delta(layer)%onedarray(q)
              end do
          end do
      end do

      deallocate(hiddensizes)
      do p = 1, size(o)
          deallocate(o(p)%onedarray)
      end do
      deallocate(o)
      do p = 1, size(ohat)
          deallocate(ohat(p)%onedarray)
      end do
      deallocate(ohat)
      do p = 1, size(delta)
          deallocate(delta(p)%onedarray)
      end do
      deallocate(delta)
      do p = 1, size(D)
          deallocate(D(p)%onedarray)
      end do
      deallocate(D)

!     changing the derivatives of the energy from derived-type
!     form into vector
      l = 0
      do j = 1, no_layers_of_elements(1) - 1
          num_rows = no_nodes_of_elements(j) + 1
          num_cols = no_nodes_of_elements(j + 1)
          do p = 1, num_rows
              do q = 1, num_cols
                  calculate_denergy_dparameters_(&
                  l + (p - 1) * num_cols + q) = &
                  unraveled_denergy_dweights(j)%twodarray(p, q)
              end do
          end do
          l = l + num_rows * num_cols
      end do

      calculate_denergy_dparameters_(l + 1) = denergy_dintercept
      calculate_denergy_dparameters_(l + 2) = denergy_dslope

!     deallocating derived-type parameters
      do p = 1, size(weights)
          deallocate(weights(p)%twodarray)
      end do
      deallocate(weights)
      do p = 1, size(unraveled_denergy_dweights)
          deallocate(unraveled_denergy_dweights(p)%twodarray)
      end do
      deallocate(unraveled_denergy_dweights)

      end function calculate_denergy_dparameters_

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     Returns derivative of energy w.r.t. parameters in the
!     atom-centered mode.
      function calculate_datomicenergy_dparameters(symbol, &
      len_of_fingerprint, fingerprint, num_elements, &
      elements_numbers, num_parameters, parameters)
      implicit none

      integer:: num_parameters, num_elements
      integer:: symbol, len_of_fingerprint
      double precision:: calculate_datomicenergy_dparameters(num_parameters)
      double precision:: parameters(num_parameters)
      double precision:: fingerprint(len_of_fingerprint)
      integer:: elements_numbers(num_elements)

      integer:: element, m, n, j, k, l, layer, p, q, nn, num_cols
      integer:: num_rows
      double precision:: temp1, temp2
      integer, allocatable:: hiddensizes(:)
      double precision, allocatable:: net(:)
      type(real_one_d_array), allocatable:: o(:), ohat(:)
      type(real_one_d_array), allocatable:: delta(:), D(:)
      type(element_parameters):: unraveled_parameters(num_elements)
      type(element_parameters):: &
      unraveled_daenergy_dparameters(num_elements)
      double precision:: fingerprint_(len_of_fingerprint)

      ! scaling fingerprints
      do element = 1, num_elements
        if (symbol == &
            elements_numbers(element)) then
            exit
        end if
      end do
      do l = 1, len_of_fingerprint
        if ((max_fingerprints(element, l) - &
        min_fingerprints(element, l)) .GT. &
        (10.0d0 ** (-8.0d0))) then
            fingerprint_(l) = -1.0d0 + 2.0d0 * &
            (fingerprint(l) - min_fingerprints(element, l)) / &
            (max_fingerprints(element, l) - &
            min_fingerprints(element, l))
        else
            fingerprint_(l) = fingerprint(l)
        endif
      end do

!     changing the form of parameters to derived types
      k = 0
      l = 0
      do element = 1, num_elements
        allocate(unraveled_parameters(element)%weights(&
        no_layers_of_elements(element)-1))
        if (element .GT. 1) then
            k = k + no_layers_of_elements(element - 1)
        end if
        do j = 1, no_layers_of_elements(element) - 1
            num_rows = no_nodes_of_elements(k + j) + 1
            num_cols = no_nodes_of_elements(k + j + 1)
            allocate(unraveled_parameters(element)%weights(&
            j)%twodarray(num_rows, num_cols))
            do p = 1, num_rows
                do q = 1, num_cols
                    unraveled_parameters(element)%weights(j)%twodarray(&
                    p, q) = parameters(l + (p - 1) * num_cols + q)
                end do
            end do
            l = l + num_rows * num_cols
        end do
      end do
      do element = 1, num_elements
        unraveled_parameters(element)%intercept = &
        parameters(l + 2 *  element - 1)
        unraveled_parameters(element)%slope = &
        parameters(l + 2 * element)
      end do

      do element = 1, num_elements
        unraveled_daenergy_dparameters(element)%intercept = 0.d0
        unraveled_daenergy_dparameters(element)%slope = 0.d0
      end do
      k = 0
      l = 0
      do element = 1, num_elements
        allocate(unraveled_daenergy_dparameters(element)%weights(&
        no_layers_of_elements(element)-1))
        if (element > 1) then
            k = k + no_layers_of_elements(element - 1)
        end if
        do j = 1, no_layers_of_elements(element) - 1
            num_rows = no_nodes_of_elements(k + j) + 1
            num_cols = no_nodes_of_elements(k + j + 1)
            allocate(unraveled_daenergy_dparameters(&
            element)%weights(j)%twodarray(num_rows, num_cols))
            do p = 1, num_rows
                do q = 1, num_cols
                    unraveled_daenergy_dparameters(&
                    element)%weights(j)%twodarray(p, q) = 0.0d0
                end do
            end do
            l = l + num_rows * num_cols
        end do
      end do

      p = 0
      do element = 1, num_elements
          if (symbol == elements_numbers(element)) then
              exit
          else
              p = p + no_layers_of_elements(element)
          end if
      end do
      allocate(hiddensizes(no_layers_of_elements(element) - 2))
      do m = 1, no_layers_of_elements(element) - 2
          hiddensizes(m) = no_nodes_of_elements(p + m + 1)
      end do
      allocate(o(no_layers_of_elements(element)))
      allocate(ohat(no_layers_of_elements(element)))
      layer = 1
      allocate(o(1)%onedarray(len_of_fingerprint))
      allocate(ohat(1)%onedarray(len_of_fingerprint + 1))
      do m = 1, len_of_fingerprint
          o(1)%onedarray(m) = fingerprint_(m)
      end do
      do layer = 1, size(hiddensizes) + 1
          do m = 1, size(unraveled_parameters(element)%weights(&
          layer)%twodarray, dim=1) - 1
              ohat(layer)%onedarray(m) = o(layer)%onedarray(m)
          end do
          ohat(layer)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=1)) = 1.0d0
          allocate(net(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2)))
          allocate(o(layer + 1)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2)))
          allocate(ohat(layer + 1)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2) + 1))
          do m = 1, size(unraveled_parameters(element)%weights(&
          layer)%twodarray, dim=2)
              net(m) = 0.0d0
              do n = 1, size(unraveled_parameters(element)%weights(&
              layer)%twodarray, dim=1)
                  net(m) =  net(m) + &
                  ohat(layer)%onedarray(n) * unraveled_parameters(&
                  element)%weights(layer)%twodarray(n, m)
              end do
              if (activation_signal == 1) then
                  o(layer + 1)%onedarray(m) = tanh(net(m))
              else if (activation_signal == 2) then
                  o(layer + 1)%onedarray(m) = &
                  1.0d0 / (1.0d0 +  exp(- net(m)))
              else if (activation_signal == 3) then
                  o(layer + 1)%onedarray(m) = net(m)
              end if
              ohat(layer + 1)%onedarray(m) = o(layer + 1)%onedarray(m)
          end do
          ohat(layer + 1)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2) + 1) =  1.0d0
          deallocate(net)
      end do

      nn = size(o) - 2
      allocate(D(nn + 1))
      do layer = 1, nn + 1
          allocate(D(layer)%onedarray(size(o(layer + 1)%onedarray)))
          do j = 1, size(o(layer + 1)%onedarray)
              if (activation_signal == 1) then
                  D(layer)%onedarray(j) = (1.0d0 - &
                  o(layer + 1)%onedarray(j)* o(layer + 1)%onedarray(j))
              elseif (activation_signal == 2) then
                  D(layer)%onedarray(j) = o(layer + 1)%onedarray(j) * &
                  (1.0d0 - o(layer + 1)%onedarray(j))
              elseif (activation_signal == 3) then
                  D(layer)%onedarray(j) = 1.0d0
              end if
          end do
      end do
      allocate(delta(nn + 1))
      allocate(delta(nn + 1)%onedarray(1))
      delta(nn + 1)%onedarray(1) = D(nn + 1)%onedarray(1)
      do layer = nn, 1, -1
          allocate(delta(layer)%onedarray(size(D(layer)%onedarray)))
          do p = 1, size(D(layer)%onedarray)
              delta(layer)%onedarray(p) = 0.0d0
              do q = 1, size(delta(layer + 1)%onedarray)
                  temp1 = D(layer)%onedarray(p) * unraveled_parameters(&
                  element)%weights(layer + 1)%twodarray(p, q)
                  temp2 = temp1  * delta(layer + 1)%onedarray(q)
                  delta(layer)%onedarray(p) = &
                  delta(layer)%onedarray(p) + temp2
              end do
          end do
      end do

      unraveled_daenergy_dparameters(element)%intercept = 1.0d0
      unraveled_daenergy_dparameters(element)%slope = &
      o(nn + 2)%onedarray(1)
      do layer = 1, nn + 1
          do p = 1, size(ohat(layer)%onedarray)
              do q = 1, size(delta(layer)%onedarray)
                  unraveled_daenergy_dparameters(element)%weights(&
                  layer)%twodarray(p, q) = &
                  unraveled_parameters(element)%slope * &
                  ohat(layer)%onedarray(p) * delta(layer)%onedarray(q)
              end do
          end do
      end do

      deallocate(hiddensizes)
      do p = 1, size(o)
          deallocate(o(p)%onedarray)
      end do
      deallocate(o)
      do p = 1, size(ohat)
          deallocate(ohat(p)%onedarray)
      end do
      deallocate(ohat)
      do p = 1, size(delta)
          deallocate(delta(p)%onedarray)
      end do
      deallocate(delta)
      do p = 1, size(D)
          deallocate(D(p)%onedarray)
      end do
      deallocate(D)

!     changing the derivatives of the energy from derived-type
!     form into vector
      k = 0
      l = 0
      do element = 1, num_elements
        if (element > 1) then
            k = k + no_layers_of_elements(element - 1)
        end if
        do j = 1, no_layers_of_elements(element) - 1
            num_rows = no_nodes_of_elements(k + j) + 1
            num_cols = no_nodes_of_elements(k + j + 1)
            do p = 1, num_rows
                do q = 1, num_cols
                    calculate_datomicenergy_dparameters(&
                    l + (p - 1) * num_cols + q) = &
                    unraveled_daenergy_dparameters(&
                    element)%weights(j)%twodarray(p, q)
                end do
            end do
            l = l + num_rows * num_cols
        end do
      end do
      do element = 1, num_elements
        calculate_datomicenergy_dparameters(l + 2 *  element - 1) = &
        unraveled_daenergy_dparameters(element)%intercept
        calculate_datomicenergy_dparameters(l + 2 * element) = &
        unraveled_daenergy_dparameters(element)%slope
      end do

!     deallocating derived-type parameters
      k = 0
      do element = 1, num_elements
        if (element .GT. 1) then
          k = k + no_layers_of_elements(element - 1)
        end if
        do j = 1, no_layers_of_elements(element) - 1
          num_rows = no_nodes_of_elements(k + j) + 1
          num_cols = no_nodes_of_elements(k + j + 1)
          deallocate(unraveled_parameters(&
          element)%weights(j)%twodarray)
          deallocate(unraveled_daenergy_dparameters(&
          element)%weights(j)%twodarray)
        end do
        deallocate(unraveled_parameters(element)%weights)
        deallocate(unraveled_daenergy_dparameters(element)%weights)
      end do

      end function calculate_datomicenergy_dparameters

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     Returns derivative of force w.r.t. parameters in the
!     image-centered mode.
      function calculate_dforce_dparameters_(num_inputs, inputs, &
      inputs_, num_parameters, parameters)
      implicit none

      integer:: num_inputs, num_parameters
      double precision:: calculate_dforce_dparameters_(num_parameters)
      double precision:: parameters(num_parameters)
      double precision:: inputs(num_inputs)
      double precision:: inputs_(num_inputs)

      integer:: m, n, j, l, layer, p, q, nn, num_cols
      integer:: num_rows
      double precision:: temp1, temp2
      integer, allocatable:: hiddensizes(:)
      double precision, allocatable:: net(:)
      type(real_one_d_array), allocatable:: o(:), ohat(:)
      type(real_one_d_array), allocatable:: delta(:), D(:)
      type(real_one_d_array), allocatable:: doutputs_dinputs(:)
      double precision, allocatable:: dohat_dinputs(:)
      type(real_one_d_array), allocatable:: dD_dinputs(:)
      type (real_one_d_array), allocatable:: ddelta_dinputs(:)
      double precision, allocatable:: &
      doutput_dinputsdweights(:, :)
      double precision, allocatable:: temp(:), temp3(:), temp4(:)
      double precision, allocatable:: temp5(:), temp6(:)
      type(real_two_d_array), allocatable:: weights(:)
      double precision:: intercept
      double precision:: slope
      type(real_two_d_array), allocatable:: unraveled_dforce_dweights(:)
      double precision:: dforce_dintercept
      double precision:: dforce_dslope

!     changing the form of parameters from vector into derived-types
      l = 0
      allocate(weights(no_layers_of_elements(1)-1))
      do j = 1, no_layers_of_elements(1) - 1
          num_rows = no_nodes_of_elements(j) + 1
          num_cols = no_nodes_of_elements(j + 1)
          allocate(weights(j)%twodarray(num_rows, num_cols))
          do p = 1, num_rows
              do q = 1, num_cols
                  weights(j)%twodarray(p, q) = &
                  parameters(l + (p - 1) * num_cols + q)
              end do
          end do
          l = l + num_rows * num_cols
      end do
      intercept = parameters(l + 1)
      slope = parameters(l + 2)

      dforce_dintercept = 0.d0
      dforce_dslope = 0.d0
      l = 0
      allocate(unraveled_dforce_dweights(no_layers_of_elements(1)-1))
      do j = 1, no_layers_of_elements(1) - 1
          num_rows = no_nodes_of_elements(j) + 1
          num_cols = no_nodes_of_elements(j + 1)
          allocate(unraveled_dforce_dweights(j)%twodarray(num_rows, &
          num_cols))
          do p = 1, num_rows
              do q = 1, num_cols
                  unraveled_dforce_dweights(j)%twodarray(p, q) = 0.0d0
              end do
          end do
          l = l + num_rows * num_cols
      end do

      allocate(hiddensizes(no_layers_of_elements(1) - 2))
      do m = 1, no_layers_of_elements(1) - 2
          hiddensizes(m) = no_nodes_of_elements(m + 1)
      end do
      allocate(o(no_layers_of_elements(1)))
      allocate(ohat(no_layers_of_elements(1)))
      layer = 1
      allocate(o(1)%onedarray(num_inputs))
      allocate(ohat(1)%onedarray(num_inputs + 1))
      do m = 1, num_inputs
          o(1)%onedarray(m) = inputs(m)
      end do
      do layer = 1, size(hiddensizes) + 1
          do m = 1, size(weights(layer)%twodarray, dim=1) - 1
              ohat(layer)%onedarray(m) = o(layer)%onedarray(m)
          end do
          ohat(layer)%onedarray(&
          size(weights(layer)%twodarray, dim=1)) = 1.0d0
          allocate(net(size(weights(layer)%twodarray, dim=2)))
          allocate(o(layer + 1)%onedarray(&
          size(weights(layer)%twodarray, dim=2)))
          allocate(ohat(layer + 1)%onedarray(&
          size(weights(layer)%twodarray, dim=2) + 1))
          do m = 1, size(weights(layer)%twodarray, dim=2)
              net(m) = 0.0d0
              do n = 1, size(weights(layer)%twodarray, dim=1)
                  net(m) =  net(m) + &
                  ohat(layer)%onedarray(n) * &
                  weights(layer)%twodarray(n, m)
              end do
              if (activation_signal == 1) then
                  o(layer + 1)%onedarray(m) = tanh(net(m))
              else if (activation_signal == 2) then
                  o(layer + 1)%onedarray(m) = &
                  1.0d0 / (1.0d0 +  exp(- net(m)))
              else if (activation_signal == 3) then
                  o(layer + 1)%onedarray(m) = net(m)
              end if
              ohat(layer + 1)%onedarray(m) = o(layer + 1)%onedarray(m)
          end do
          ohat(layer + 1)%onedarray(&
          size(weights(layer)%twodarray, dim=2) + 1) =  1.0d0
          deallocate(net)
      end do

      nn = size(o) - 2
      allocate(D(nn + 1))
      do layer = 1, nn + 1
          allocate(D(layer)%onedarray(size(o(layer + 1)%onedarray)))
          do j = 1, size(o(layer + 1)%onedarray)
              if (activation_signal == 1) then
                  D(layer)%onedarray(j) = (1.0d0 - &
                  o(layer + 1)%onedarray(j)* o(layer + 1)%onedarray(j))
              elseif (activation_signal == 2) then
                  D(layer)%onedarray(j) = o(layer + 1)%onedarray(j) * &
                  (1.0d0 - o(layer + 1)%onedarray(j))
              elseif (activation_signal == 3) then
                  D(layer)%onedarray(j) = 1.0d0
              end if
          end do
      end do
      allocate(delta(nn + 1))
      allocate(delta(nn + 1)%onedarray(1))
      delta(nn + 1)%onedarray(1) = D(nn + 1)%onedarray(1)
      do layer = nn, 1, -1
          allocate(delta(layer)%onedarray(size(D(layer)%onedarray)))
          do p = 1, size(D(layer)%onedarray)
              delta(layer)%onedarray(p) = 0.0d0
              do q = 1, size(delta(layer + 1)%onedarray)
                  temp1 = D(layer)%onedarray(p) * weights(&
                  layer + 1)%twodarray(p, q)
                  temp2 = temp1  * delta(layer + 1)%onedarray(q)
                  delta(layer)%onedarray(p) = &
                  delta(layer)%onedarray(p) + temp2
              end do
          end do
      end do

      allocate(doutputs_dinputs(nn + 2))
      allocate(doutputs_dinputs(1)%onedarray(num_inputs))
      do m = 1, num_inputs
        doutputs_dinputs(1)%onedarray(m) = inputs_(m)
      end do
      do layer = 1, nn + 1
          allocate(temp(size(weights(layer)%twodarray, dim = 2)))
          do p = 1, size(weights(layer)%twodarray, dim = 2)
              temp(p) = 0.0d0
              do q = 1, size(weights(layer)%twodarray, dim = 1) - 1
                  temp(p) = temp(p) + doutputs_dinputs(&
                  layer)%onedarray(q) * weights(layer)%twodarray(q, p)
              end do
          end do
          q = size(o(layer + 1)%onedarray)
          allocate(doutputs_dinputs(layer + 1)%onedarray(q))
          do p = 1, size(o(layer + 1)%onedarray)
              if (activation_signal == 1) then
                doutputs_dinputs(layer + 1)%onedarray(p) = temp(p) * &
                (1.0d0 - o(layer + 1)%onedarray(p) * &
                o(layer + 1)%onedarray(p))
              else if (activation_signal == 2) then
                doutputs_dinputs(layer + 1)%onedarray(p) = &
                temp(p) * (1.0d0 - o(layer + 1)%onedarray(p)) * &
                o(layer + 1)%onedarray(p)
              else if (activation_signal == 3) then
                doutputs_dinputs(layer+ 1)%onedarray(p) = temp(p)
              end if
          end do
          deallocate(temp)
      end do

      allocate(dD_dinputs(nn + 1))
      do layer = 1, nn + 1
          allocate(dD_dinputs(layer)%onedarray(&
          size(o(layer + 1)%onedarray)))
          do p = 1, size(o(layer + 1)%onedarray)
              if (activation_signal == 1) then
                  dD_dinputs(layer)%onedarray(p) = &
                  - 2.0d0 * o(layer + 1)%onedarray(p) * &
                  doutputs_dinputs(layer + 1)%onedarray(p)
              elseif (activation_signal == 2) then
                  dD_dinputs(layer)%onedarray(p) = &
                  doutputs_dinputs(layer + 1)%onedarray(p) * &
                  (1.0d0 - 2.0d0 * o(layer + 1)%onedarray(p))
              elseif (activation_signal == 3) then
                  dD_dinputs(layer)%onedarray(p) =0.0d0
              end if
          end do
      end do

      allocate(ddelta_dinputs(nn + 1))
      allocate(ddelta_dinputs(nn + 1)%onedarray(1))
      ddelta_dinputs(nn + 1)%onedarray(1) = &
      dD_dinputs(nn + 1)%onedarray(1)

      do layer = nn, 1, -1
          allocate(temp3(&
          size(weights(layer + 1)%twodarray, dim = 1) - 1))
          allocate(temp4(&
          size(weights(layer + 1)%twodarray, dim = 1) - 1))
          do p = 1, size(weights(layer + 1)%twodarray, dim = 1) - 1
              temp3(p) = 0.0d0
              temp4(p) = 0.0d0
              do q = 1, size(delta(layer + 1)%onedarray)
                  temp3(p) = temp3(p) + weights(layer + 1)%twodarray(&
                  p, q) * delta(layer + 1)%onedarray(q)
                  temp4(p) = temp4(p) + weights(layer + 1)%twodarray(&
                  p, q) * ddelta_dinputs(layer + 1)%onedarray(q)
              end do
          end do
          allocate(temp5(size(dD_dinputs(layer)%onedarray)))
          allocate(temp6(size(dD_dinputs(layer)%onedarray)))
          allocate(ddelta_dinputs(layer)%onedarray(&
          size(dD_dinputs(layer)%onedarray)))
          do p = 1, size(dD_dinputs(layer)%onedarray)
              temp5(p) = &
              dD_dinputs(layer)%onedarray(p) * temp3(p)
              temp6(p) = D(layer)%onedarray(p) * temp4(p)
              ddelta_dinputs(layer)%onedarray(p)= &
              temp5(p) + temp6(p)
          end do
          deallocate(temp3)
          deallocate(temp4)
          deallocate(temp5)
          deallocate(temp6)
      end do

      dforce_dslope = doutputs_dinputs(nn + 2)%onedarray(1)
      ! force is multiplied by -1, because it is -dE/dx and not dE/dx.
      dforce_dslope = -1.0d0 * dforce_dslope
      do layer = 1, nn + 1
          allocate(dohat_dinputs(&
          size(doutputs_dinputs(layer)%onedarray) + 1))
          do p = 1, size(doutputs_dinputs(layer)%onedarray)
              dohat_dinputs(p) = &
              doutputs_dinputs(layer)%onedarray(p)
          end do
          dohat_dinputs(&
          size(doutputs_dinputs(layer)%onedarray) + 1) = 0.0d0
          allocate(doutput_dinputsdweights(&
          size(dohat_dinputs), size(delta(layer)%onedarray)))
          do p = 1, size(dohat_dinputs)
              do q = 1, size(delta(layer)%onedarray)
                  doutput_dinputsdweights(p, q)= 0.0d0
              end do
          end do
          do p = 1, size(dohat_dinputs)
              do q = 1, size(delta(layer)%onedarray)
              doutput_dinputsdweights(p, q) = &
              doutput_dinputsdweights(p, q) + &
              dohat_dinputs(p) * delta(layer)%onedarray(q) + &
              ohat(layer)%onedarray(p)* &
              ddelta_dinputs(layer)%onedarray(q)
              end do
          end do
          do p = 1, size(ohat(layer)%onedarray)
              do q = 1, size(delta(layer)%onedarray)
              unraveled_dforce_dweights(layer)%twodarray(p, q) = &
              slope * doutput_dinputsdweights(p, q)
              ! force is multiplied by -1, because it is -dE/dx and
              ! not dE/dx.
                unraveled_dforce_dweights(layer)%twodarray(p, q) = &
               -1.0d0 * unraveled_dforce_dweights(layer)%twodarray(p, q)
              end do
          end do
          deallocate(dohat_dinputs)
          deallocate(doutput_dinputsdweights)
      end do

!     deallocating neural network
      deallocate(hiddensizes)
      do p = 1, size(o)
          deallocate(o(p)%onedarray)
      end do
      deallocate(o)
      do p = 1, size(ohat)
          deallocate(ohat(p)%onedarray)
      end do
      deallocate(ohat)
      do p = 1, size(delta)
          deallocate(delta(p)%onedarray)
      end do
      deallocate(delta)
      do p = 1, size(D)
          deallocate(D(p)%onedarray)
      end do
      deallocate(D)
      do p = 1, size(doutputs_dinputs)
          deallocate(doutputs_dinputs(p)%onedarray)
      end do
      deallocate(doutputs_dinputs)
      do p = 1, size(ddelta_dinputs)
          deallocate(ddelta_dinputs(p)%onedarray)
      end do
      deallocate(ddelta_dinputs)
      do p = 1, size(dD_dinputs)
          deallocate(dD_dinputs(p)%onedarray)
      end do
      deallocate(dD_dinputs)

      l = 0
      do j = 1, no_layers_of_elements(1) - 1
          num_rows = no_nodes_of_elements(j) + 1
          num_cols = no_nodes_of_elements(j + 1)
          do p = 1, num_rows
              do q = 1, num_cols
                  calculate_dforce_dparameters_(&
                  l + (p - 1) * num_cols + q) = &
                  unraveled_dforce_dweights(j)%twodarray(p, q)
              end do
          end do
          l = l + num_rows * num_cols
      end do
      calculate_dforce_dparameters_(l + 1) = dforce_dintercept
      calculate_dforce_dparameters_(l + 2) = dforce_dslope

!     deallocating derived-type parameters
      do p = 1, size(weights)
          deallocate(weights(p)%twodarray)
      end do
      deallocate(weights)
      do p = 1, size(unraveled_dforce_dweights)
          deallocate(unraveled_dforce_dweights(p)%twodarray)
      end do
      deallocate(unraveled_dforce_dweights)

      end function calculate_dforce_dparameters_

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     Returns derivative of force w.r.t. parameters in the
!     atom-centered mode
      function calculate_dforce_dparameters(symbol, len_of_fingerprint, &
      fingerprint, fingerprintprime, num_elements, elements_numbers, &
      num_parameters, parameters)
      implicit none

      integer:: symbol, len_of_fingerprint
      integer:: num_parameters, num_elements
      double precision:: fingerprint(len_of_fingerprint)
      double precision:: fingerprintprime(len_of_fingerprint)
      integer:: elements_numbers(num_elements)
      double precision:: parameters(num_parameters)
      double precision:: calculate_dforce_dparameters(num_parameters)

      integer:: element, m, n, j, k, l, layer, p, q, nn, num_cols
      integer:: num_rows
      double precision:: temp1, temp2
      integer, allocatable:: hiddensizes(:)
      double precision, allocatable:: net(:)
      type(real_one_d_array), allocatable:: o(:), ohat(:)
      type(real_one_d_array), allocatable:: delta(:), D(:)
      type(real_one_d_array), allocatable:: doutputs_dinputs(:)
      double precision, allocatable:: dohat_dinputs(:)
      type(real_one_d_array), allocatable:: dD_dinputs(:)
      type (real_one_d_array), allocatable:: ddelta_dinputs(:)
      double precision, allocatable:: &
      doutput_dinputsdweights(:, :)
      double precision, allocatable:: temp(:), temp3(:), temp4(:)
      double precision, allocatable:: temp5(:), temp6(:)
      type(element_parameters):: unraveled_parameters(num_elements)
      type(element_parameters):: &
      unraveled_dforce_dparameters(num_elements)
      double precision:: fingerprint_(len_of_fingerprint)
      double precision:: fingerprintprime_(len_of_fingerprint)

      ! scaling fingerprints
      do element = 1, num_elements
        if (symbol == &
            elements_numbers(element)) then
            exit
        end if
      end do
      do l = 1, len_of_fingerprint
        if ((max_fingerprints(element, l) - &
        min_fingerprints(element, l)) .GT. &
        (10.0d0 ** (-8.0d0))) then
            fingerprint_(l) = -1.0d0 + 2.0d0 * &
            (fingerprint(l) - min_fingerprints(element, l)) / &
            (max_fingerprints(element, l) - &
            min_fingerprints(element, l))
        else
            fingerprint_(l) = fingerprint(l)
        endif
      end do
      ! scaling fingerprintprimes
      do l = 1, len_of_fingerprint
        if ((max_fingerprints(element, l) - &
        min_fingerprints(element, l)) .GT. &
        (10.0d0 ** (-8.0d0))) then
            fingerprintprime_(l) = &
            2.0d0 * fingerprintprime(l) / &
            (max_fingerprints(element, l) - &
            min_fingerprints(element, l))
        else
            fingerprintprime_(l) = fingerprintprime(l)
        endif
      end do

!     changing the form of parameters from vector into derived-types
      k = 0
      l = 0
      do element = 1, num_elements
        allocate(unraveled_parameters(element)%weights(&
        no_layers_of_elements(element)-1))
        if (element .GT. 1) then
            k = k + no_layers_of_elements(element - 1)
        end if
        do j = 1, no_layers_of_elements(element) - 1
            num_rows = no_nodes_of_elements(k + j) + 1
            num_cols = no_nodes_of_elements(k + j + 1)
            allocate(unraveled_parameters(&
            element)%weights(j)%twodarray(num_rows, num_cols))
            do p = 1, num_rows
                do q = 1, num_cols
                    unraveled_parameters(element)%weights(j)%twodarray(&
                    p, q) = parameters(l + (p - 1) * num_cols + q)
                end do
            end do
            l = l + num_rows * num_cols
        end do
      end do
      do element = 1, num_elements
        unraveled_parameters(element)%intercept = &
        parameters(l + 2 *  element - 1)
        unraveled_parameters(element)%slope = &
        parameters(l + 2 * element)
      end do

      do element = 1, num_elements
        unraveled_dforce_dparameters(element)%intercept = 0.d0
        unraveled_dforce_dparameters(element)%slope = 0.d0
      end do
      k = 0
      l = 0
      do element = 1, num_elements
        allocate(unraveled_dforce_dparameters(element)%weights(&
        no_layers_of_elements(element)-1))
        if (element > 1) then
            k = k + no_layers_of_elements(element - 1)
        end if
        do j = 1, no_layers_of_elements(element) - 1
            num_rows = no_nodes_of_elements(k + j) + 1
            num_cols = no_nodes_of_elements(k + j + 1)
            allocate(unraveled_dforce_dparameters(&
            element)%weights(j)%twodarray(num_rows, num_cols))
            do p = 1, num_rows
                do q = 1, num_cols
                    unraveled_dforce_dparameters(&
                    element)%weights(j)%twodarray(p, q) = 0.0d0
                end do
            end do
            l = l + num_rows * num_cols
        end do
      end do

      p = 0
      do element = 1, num_elements
          if (symbol == elements_numbers(element)) then
              exit
          else
              p = p + no_layers_of_elements(element)
          end if
      end do

      allocate(hiddensizes(no_layers_of_elements(element) - 2))
      do m = 1, no_layers_of_elements(element) - 2
          hiddensizes(m) = no_nodes_of_elements(p + m + 1)
      end do
      allocate(o(no_layers_of_elements(element)))
      allocate(ohat(no_layers_of_elements(element)))
      layer = 1
      allocate(o(1)%onedarray(len_of_fingerprint))
      allocate(ohat(1)%onedarray(len_of_fingerprint + 1))
      do m = 1, len_of_fingerprint
          o(1)%onedarray(m) = fingerprint_(m)
      end do
      do layer = 1, size(hiddensizes) + 1
          do m = 1, size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=1) - 1
              ohat(layer)%onedarray(m) = o(layer)%onedarray(m)
          end do
          ohat(layer)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=1)) = 1.0d0
          allocate(net(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2)))
          allocate(o(layer + 1)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2)))
          allocate(ohat(layer + 1)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2) + 1))
          do m = 1, size(unraveled_parameters(element)%weights(&
          layer)%twodarray, dim=2)
              net(m) = 0.0d0
              do n = 1, size(unraveled_parameters(element)%weights(&
              layer)%twodarray, dim=1)
                  net(m) =  net(m) + &
                  ohat(layer)%onedarray(n) * &
                  unraveled_parameters(element)%weights(&
                  layer)%twodarray(n, m)
              end do
              if (activation_signal == 1) then
                  o(layer + 1)%onedarray(m) = tanh(net(m))
              else if (activation_signal == 2) then
                  o(layer + 1)%onedarray(m) = &
                  1.0d0 / (1.0d0 +  exp(- net(m)))
              else if (activation_signal == 3) then
                  o(layer + 1)%onedarray(m) = net(m)
              end if
              ohat(layer + 1)%onedarray(m) = o(layer + 1)%onedarray(m)
          end do
          ohat(layer + 1)%onedarray(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim=2) + 1) =  1.0d0
          deallocate(net)
      end do

      nn = size(o) - 2

      allocate(D(nn + 1))
      do layer = 1, nn + 1
          allocate(D(layer)%onedarray(size(o(layer + 1)%onedarray)))
          do j = 1, size(o(layer + 1)%onedarray)
              if (activation_signal == 1) then
                  D(layer)%onedarray(j) = &
                  (1.0d0 - o(layer + 1)%onedarray(j)* &
                  o(layer + 1)%onedarray(j))
              elseif (activation_signal == 2) then
                  D(layer)%onedarray(j) = o(layer + 1)%onedarray(j) * &
                  (1.0d0 - o(layer + 1)%onedarray(j))
              elseif (activation_signal == 3) then
                  D(layer)%onedarray(j) = 1.0d0
              end if
          end do
      end do
      allocate(delta(nn + 1))
      allocate(delta(nn + 1)%onedarray(1))
      delta(nn + 1)%onedarray(1) = D(nn + 1)%onedarray(1)
      do layer = nn, 1, -1
          allocate(delta(layer)%onedarray(size(D(layer)%onedarray)))
          do p = 1, size(D(layer)%onedarray)
              delta(layer)%onedarray(p) = 0.0d0
              do q = 1, size(delta(layer + 1)%onedarray)
                  temp1 = D(layer)%onedarray(p) * &
                  unraveled_parameters(element)%weights(&
                  layer + 1)%twodarray(p, q)
                  temp2 = temp1  * delta(layer + 1)%onedarray(q)
                  delta(layer)%onedarray(p) = &
                  delta(layer)%onedarray(p) + temp2
              end do
          end do
      end do

      allocate(doutputs_dinputs(nn + 2))
      allocate(doutputs_dinputs(1)%onedarray(&
      len_of_fingerprint))
      do m = 1, len_of_fingerprint
        doutputs_dinputs(1)%onedarray(m) = fingerprintprime_(m)
      end do
      do layer = 1, nn + 1
          allocate(temp(size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim = 2)))
          do p = 1, size(unraveled_parameters(&
          element)%weights(layer)%twodarray, dim = 2)
              temp(p) = 0.0d0
              do q = 1, size(unraveled_parameters(&
              element)%weights(layer)%twodarray, dim = 1) - 1
                  temp(p) = temp(p) + doutputs_dinputs(&
                  layer)%onedarray(q) * unraveled_parameters(&
                  element)%weights(layer)%twodarray(q, p)
              end do
          end do
          q = size(o(layer + 1)%onedarray)
          allocate(doutputs_dinputs(layer + 1)%onedarray(q))
          do p = 1, size(o(layer + 1)%onedarray)
              if (activation_signal == 1) then
                doutputs_dinputs(layer + 1)%onedarray(p) = temp(p) * &
                (1.0d0 - o(layer + 1)%onedarray(p) * &
                o(layer + 1)%onedarray(p))
              else if (activation_signal == 2) then
                doutputs_dinputs(layer + 1)%onedarray(p) = temp(p) * &
                (1.0d0 - o(layer + 1)%onedarray(p)) * &
                o(layer + 1)%onedarray(p)
              else if (activation_signal == 3) then
                doutputs_dinputs(layer+ 1)%onedarray(p) = temp(p)
              end if
          end do
          deallocate(temp)
      end do

      allocate(dD_dinputs(nn + 1))
      do layer = 1, nn + 1
          allocate(dD_dinputs(layer)%onedarray(&
          size(o(layer + 1)%onedarray)))
          do p = 1, size(o(layer + 1)%onedarray)
              if (activation_signal == 1) then
                  dD_dinputs(layer)%onedarray(p) =- 2.0d0 * &
                  o(layer + 1)%onedarray(p) * &
                  doutputs_dinputs(layer + 1)%onedarray(p)
              elseif (activation_signal == 2) then
                  dD_dinputs(layer)%onedarray(p) = &
                  doutputs_dinputs(layer + 1)%onedarray(p) * &
                  (1.0d0 - 2.0d0 * o(layer + 1)%onedarray(p))
              elseif (activation_signal == 3) then
                  dD_dinputs(layer)%onedarray(p) =0.0d0
              end if
          end do
      end do

      allocate(ddelta_dinputs(nn + 1))
      allocate(ddelta_dinputs(nn + 1)%onedarray(1))
      ddelta_dinputs(nn + 1)%onedarray(1) = &
      dD_dinputs(nn + 1)%onedarray(1)

      do layer = nn, 1, -1
          allocate(temp3(size(unraveled_parameters(element)%weights(&
          layer + 1)%twodarray, dim = 1) - 1))
          allocate(temp4(size(unraveled_parameters(element)%weights(&
          layer + 1)%twodarray, dim = 1) - 1))
          do p = 1, size(unraveled_parameters(element)%weights(&
          layer + 1)%twodarray, dim = 1) - 1
              temp3(p) = 0.0d0
              temp4(p) = 0.0d0
              do q = 1, size(delta(layer + 1)%onedarray)
                  temp3(p) = temp3(p) + unraveled_parameters(&
                  element)%weights(layer + 1)%twodarray(p, q) * &
                  delta(layer + 1)%onedarray(q)
                  temp4(p) = temp4(p) + unraveled_parameters(&
                  element)%weights(layer + 1)%twodarray(p, q) * &
                  ddelta_dinputs(layer + 1)%onedarray(q)
              end do
          end do
          allocate(temp5(size(dD_dinputs(layer)%onedarray)))
          allocate(temp6(size(dD_dinputs(layer)%onedarray)))
          allocate(ddelta_dinputs(layer)%onedarray(&
          size(dD_dinputs(layer)%onedarray)))
          do p = 1, size(dD_dinputs(layer)%onedarray)
              temp5(p) = &
              dD_dinputs(layer)%onedarray(p) * temp3(p)
              temp6(p) = D(layer)%onedarray(p) * temp4(p)
              ddelta_dinputs(layer)%onedarray(p)= &
              temp5(p) + temp6(p)
          end do
          deallocate(temp3)
          deallocate(temp4)
          deallocate(temp5)
          deallocate(temp6)
      end do

      unraveled_dforce_dparameters(element)%slope = &
      doutputs_dinputs(nn + 2)%onedarray(1)
      ! force is multiplied by -1, because it is -dE/dx and not dE/dx.
      unraveled_dforce_dparameters(element)%slope = &
      -1.0d0 * unraveled_dforce_dparameters(element)%slope
      do layer = 1, nn + 1
          allocate(dohat_dinputs(&
          size(doutputs_dinputs(layer)%onedarray) + 1))
          do p = 1, size(doutputs_dinputs(layer)%onedarray)
              dohat_dinputs(p) = &
              doutputs_dinputs(layer)%onedarray(p)
          end do
          dohat_dinputs(&
          size(doutputs_dinputs(layer)%onedarray) + 1) = 0.0d0
          allocate(doutput_dinputsdweights(&
          size(dohat_dinputs), size(delta(layer)%onedarray)))
          do p = 1, size(dohat_dinputs)
              do q = 1, size(delta(layer)%onedarray)
                  doutput_dinputsdweights(p, q)= 0.0d0
              end do
          end do
          do p = 1, size(dohat_dinputs)
              do q = 1, size(delta(layer)%onedarray)
              doutput_dinputsdweights(p, q) = &
              doutput_dinputsdweights(p, q) + &
              dohat_dinputs(p) * delta(layer)%onedarray(q) + &
              ohat(layer)%onedarray(p)* &
              ddelta_dinputs(layer)%onedarray(q)
              end do
          end do
          do p = 1, size(ohat(layer)%onedarray)
              do q = 1, size(delta(layer)%onedarray)
              unraveled_dforce_dparameters(element)%weights(&
              layer)%twodarray(p, q) = &
              unraveled_parameters(element)%slope * &
              doutput_dinputsdweights(p, q)
              ! force is multiplied by -1, because it is -dE/dx and
              ! not dE/dx.
              unraveled_dforce_dparameters(element)%weights(&
              layer)%twodarray(p, q) = &
              -1.0d0 * unraveled_dforce_dparameters(element)%weights(&
              layer)%twodarray(p, q)
              end do
          end do
          deallocate(dohat_dinputs)
          deallocate(doutput_dinputsdweights)
      end do

!     deallocating neural network
      deallocate(hiddensizes)
      do p = 1, size(o)
          deallocate(o(p)%onedarray)
      end do
      deallocate(o)
      do p = 1, size(ohat)
          deallocate(ohat(p)%onedarray)
      end do
      deallocate(ohat)
      do p = 1, size(delta)
          deallocate(delta(p)%onedarray)
      end do
      deallocate(delta)
      do p = 1, size(D)
          deallocate(D(p)%onedarray)
      end do
      deallocate(D)
      do p = 1, size(doutputs_dinputs)
          deallocate(doutputs_dinputs(p)%onedarray)
      end do
      deallocate(doutputs_dinputs)
      do p = 1, size(ddelta_dinputs)
          deallocate(ddelta_dinputs(p)%onedarray)
      end do
      deallocate(ddelta_dinputs)
      do p = 1, size(dD_dinputs)
          deallocate(dD_dinputs(p)%onedarray)
      end do
      deallocate(dD_dinputs)

      k = 0
      l = 0
      do element = 1, num_elements
        if (element > 1) then
            k = k + no_layers_of_elements(element - 1)
        end if
        do j = 1, no_layers_of_elements(element) - 1
            num_rows = no_nodes_of_elements(k + j) + 1
            num_cols = no_nodes_of_elements(k + j + 1)
            do p = 1, num_rows
                do q = 1, num_cols
                    calculate_dforce_dparameters(&
                    l + (p - 1) * num_cols + q) = &
                    unraveled_dforce_dparameters(&
                    element)%weights(j)%twodarray(p, q)
                end do
            end do
            l = l + num_rows * num_cols
        end do
      end do
      do element = 1, num_elements
        calculate_dforce_dparameters(l + 2 *  element - 1) = &
        unraveled_dforce_dparameters(element)%intercept
        calculate_dforce_dparameters(l + 2 * element) = &
        unraveled_dforce_dparameters(element)%slope
      end do

!     deallocating derived-type parameters
      k = 0
      do element = 1, num_elements
        if (element .GT. 1) then
          k = k + no_layers_of_elements(element - 1)
        end if
        do j = 1, no_layers_of_elements(element) - 1
          num_rows = no_nodes_of_elements(k + j) + 1
          num_cols = no_nodes_of_elements(k + j + 1)
          deallocate(unraveled_parameters(&
          element)%weights(j)%twodarray)
          deallocate(unraveled_dforce_dparameters(&
          element)%weights(j)%twodarray)
        end do
        deallocate(unraveled_parameters(element)%weights)
        deallocate(unraveled_dforce_dparameters(element)%weights)
      end do

      end function calculate_dforce_dparameters

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      end module neuralnetwork

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        subroutine calculate_zernike_prime(n, l, n_length, n_indices, &
              numbers, rs, g_numbers, cutoff, indexx,  home, p, q, &
              fac_length, factorial, norm_prime, cutofffn_code, p_gamma)
        use cutoffs
        implicit none
        integer::  n, l
        integer::  indexx, p, q, n_length, fac_length
        integer, dimension(n_length)::  n_indices, numbers, g_numbers
        double precision, dimension(n_length, 3)::  rs
        double precision, dimension(3)::  home
        double precision, dimension(fac_length)::  factorial
        double precision::  cutoff
        ! gamma parameter for the polynomial cutoff
        double precision, optional:: p_gamma
        integer:: cutofffn_code
        complex*16::  norm_prime
!f2py   intent(in)::  n, l, n_indices, numbers, g_numbers, rs, p_gamma
!f2py   intent(in)::  home, indexx, p, q, cutoff, n_length, fac_length
!f2py   intent(out)::  norm_prime
        integer::  m
        complex*16::  c_nlm, c_nlm_prime, z_nlm_, z_nlm, &
        z_nlm_prime, z_nlm_prime_
        integer::  n_index, n_symbol, iter
        double precision, dimension(3)::  neighbor
        double precision::  x, y, z, rho

        norm_prime = (0.0d0, 0.0d0)

        do m = 0, l
            c_nlm = (0.0d0, 0.0d0)
            c_nlm_prime = (0.0d0, 0.0d0)
            do iter = 1, n_length
                n_index = n_indices(iter)
                n_symbol = numbers(iter)
                neighbor(1) = rs(iter, 1)
                neighbor(2) = rs(iter, 2)
                neighbor(3) = rs(iter, 3)
                x = (neighbor(1) - home(1)) / cutoff
                y = (neighbor(2) - home(2)) / cutoff
                z = (neighbor(3) - home(3)) / cutoff
                rho = (x ** 2.0d0 + y ** 2.0d0 + z ** 2.0d0) ** 0.5d0

                call calculate_z(n, l, m, x, y, z, factorial, &
                    fac_length, z_nlm_)

                ! Calculate z_nlm
                if (present(p_gamma)) then
                    z_nlm = z_nlm_ * cutoff_fxn(rho * cutoff, &
                    cutoff, cutofffn_code, p_gamma)
                    ! Calculates z_nlm_prime
                    z_nlm_prime = z_nlm_ * &
                    cutoff_fxn_prime(rho * cutoff, cutoff, &
                    cutofffn_code, p_gamma) * &
                    der_position(indexx, n_index, home, neighbor, p, q)
                else
                    z_nlm = z_nlm_ * cutoff_fxn(rho * cutoff, &
                    cutoff, cutofffn_code)
                    ! Calculates z_nlm_prime
                    z_nlm_prime = z_nlm_ * &
                    cutoff_fxn_prime(rho * cutoff, cutoff, &
                    cutofffn_code) * &
                    der_position(indexx, n_index, home, neighbor, p, q)
                endif

                call calculate_z_prime(n, l, m, x, y, z, q, factorial, &
                fac_length, z_nlm_prime_)

                if (kronecker(n_index, p) - &
                kronecker(indexx, p) == 1) then
                    if (present(p_gamma)) then
                        z_nlm_prime = z_nlm_prime + &
                        cutoff_fxn(rho * cutoff, cutoff, &
                        cutofffn_code, p_gamma) * z_nlm_prime_ / &
                        cutoff
                    else
                        z_nlm_prime = z_nlm_prime + &
                        cutoff_fxn(rho * cutoff, cutoff, &
                        cutofffn_code) * z_nlm_prime_ / cutoff
                    end if
                else if (kronecker(n_index, p) - kronecker(indexx, p) &
                    == -1) then
                    if (present(p_gamma)) then
                        z_nlm_prime = z_nlm_prime - &
                        cutoff_fxn(rho * cutoff, cutoff, &
                        cutofffn_code, p_gamma) * z_nlm_prime_ / &
                        cutoff
                    else
                        z_nlm_prime = z_nlm_prime - &
                        cutoff_fxn(rho * cutoff, cutoff, &
                        cutofffn_code) * z_nlm_prime_ / cutoff
                    end if
                end if

                ! sum over neighbors
                c_nlm = c_nlm + g_numbers(iter) * conjg(z_nlm)
                c_nlm_prime = c_nlm_prime + &
                g_numbers(iter) * conjg(z_nlm_prime)
            end do
           ! sum over m values
            if (m == 0) then
            norm_prime = norm_prime + &
            2.0d0 * c_nlm * conjg(c_nlm_prime)
            else
            norm_prime = norm_prime + &
            4.0d0 * c_nlm * conjg(c_nlm_prime)
            end if
        enddo

        CONTAINS

        function der_position(mm, nn, Rm, Rn, ll, ii)
        implicit none
        integer::  mm, nn, ll, ii, xyz
        double precision, dimension(3)::  Rm, Rn, Rmn_
        double precision::  der_position, Rmn
        do xyz = 1, 3
            Rmn_(xyz) = Rm(xyz) - Rn(xyz)
        end do
        Rmn = sqrt(dot_product(Rmn_, Rmn_))

        if ((ll == mm) .AND. (mm /= nn)) then
            der_position = (Rm(ii + 1) - Rn(ii + 1)) / Rmn
        else if ((ll == nn) .AND. (mm /= nn)) then
            der_position = - (Rm(ii + 1) - Rn(ii + 1)) / Rmn
        else
            der_position = 0.0d0
        end if
        end function

        function kronecker(i, j)
        implicit none
        integer::  i, j
        integer::  kronecker

        if (i == j) then
            kronecker = 1
        else
            kronecker = 0
        end if
        end function

        end subroutine calculate_zernike_prime

        subroutine calculate_z(n, l, m, x, y, z, factorial, length, &
                output)
        implicit none
        integer::  n, l, m, length
        double precision::  x, y, z
        double precision, dimension(length)::  factorial
        complex*16::  output, ii, term4, term6
!f2py   intent(in)::  n, l, m, x, y, z, factorial, length
!f2py   intent(out)::  output
        integer::  k, nu, alpha, beta, eta, u, mu, r, s, t
        double precision::  term1, term2, q, b1, b2, term3
        double precision::  term5, b5, b6, b7, b8, pi

        pi = 4.0d0 * datan(1.0d0)

        output = (0.0d0, 0.0d0)
        term1 = sqrt((2.0d0 * l + 1.0d0) * &
        factorial(int(2 * (l + m)) + 1) * &
        factorial(int(2 * (l - m)) + 1)) / factorial(int(2 * l) + 1)
        term2 = 2.0d0 ** (-m)
        ii = (0.0d0, 1.0d0)
        k = int((n - l) / 2.0d0)
        do nu = 0, k
            call calculate_q(nu, k, l, factorial, length, q)
            do alpha = 0, nu
                call binomial(float(nu), float(alpha), &
                    factorial, length, b1)
                do beta = 0, nu - alpha
                    call binomial(float(nu - alpha), float(beta), &
                        factorial, length, b2)
                    term3 = q * b1 * b2
                    do u = 0, m
                        call binomial(float(m), float(u), factorial, &
                            length, b5)
                            term4 = ((-1.0d0)**(m - u)) * b5 * (ii**u)
                        do mu = 0, int((l - m) / 2.0d0)
                            call binomial(float(l), float(mu), &
                                factorial, length, b6)
                            call binomial(float(l - mu), float(m + mu),&
                                factorial, length, b7)
                            term5 = ((-1.0d0) ** mu) * (2.0d0 ** &
                                (-2.0d0 * mu)) * b6 * b7
                            do eta = 0, mu
                                call binomial(float(mu), float(eta), &
                                    factorial, length, b8)
                                r = 2 * (eta + alpha) + u
                                s = 2 * (mu - eta + beta) + m - u
                                t = 2 * (nu - alpha - beta - mu) + l - m
                                output = output + term3 * term4 &
                                    * term5 * b8 * (x ** r) &
                                    *  (y ** s) * (z ** t)
                            end do
                        end do
                    end do
                end do
            end do
        end do
        term6 = (ii) ** m
        output = term1 * term2 * term6 * output
        output = output / sqrt(4.0d0 * pi / 3.0d0)
        end subroutine calculate_z

        subroutine calculate_z_prime(n, l, m, x, y, z, p, factorial, &
                length, output)
        implicit none
        integer::  n, l, m, length, p
        double precision::  x, y, z
        double precision, dimension(length)::  factorial
        complex*16::  output, ii, coefficient, term4, term6
!f2py   intent(in)::  n, l, m, x, y, z, factorial, p, length
!f2py   intent(out)::  output
        integer::  k, nu, alpha, beta, eta, u, mu, r, s, t
        double precision::  term1, term2, q, b1, b2, term3
        double precision::  term5, b3, b4, b5, b6, pi

        pi = 4.0d0 * datan(1.0d0)

        output = (0.0d0, 0.0d0)
        term1 = sqrt((2.0d0 * l + 1.0d0) * &
        factorial(int(2 * (l + m)) + 1) * &
        factorial(int(2 * (l - m)) + 1)) / &
        factorial(int(2 * l) + 1)
        term2 = 2.0d0 ** (-m)
        ii = (0.0d0, 1.0d0)

        k = int((n - l) / 2.)
        do nu = 0, k
            call calculate_q(nu, k, l, factorial, length, q)
            do alpha = 0, nu
                call binomial(float(nu), float(alpha), factorial, &
                    length, b1)
                do beta = 0, nu - alpha
                    call binomial(float(nu - alpha), float(beta), &
                        factorial, length, b2)
                term3 = q * b1 * b2
                do u = 0, m
                  call binomial(float(m), float(u), factorial, length, &
                  b3)
                  term4 = ((-1.0d0)**(m - u)) * b3 * (ii**u)
                  do mu = 0, int((l - m) / 2.)
                    call binomial(float(l), float(mu), factorial, &
                    length, b4)
                    call binomial(float(l - mu), float(m + mu), &
                    factorial, length, b5)
                    term5 = &
                    ((-1.0d0)**mu) * (2.0d0**(-2.0d0 * mu)) * b4 * b5
                    do eta = 0, mu
                      call binomial(float(mu), float(eta), factorial, &
                      length, b6)
                      r = 2 * (eta + alpha) + u
                      s = 2 * (mu - eta + beta) + m - u
                      t = 2 * (nu - alpha - beta - mu) + l - m
                      coefficient = term3 * term4 * term5 * b6
                      if (p == 0) then
                        if (r .NE. 0) then
                          output = output + coefficient * r * &
                                   (x ** (r - 1)) * (y ** s) * (z ** t)
                        end if
                      else if (p == 1) then
                        if (s .NE. 0) then
                          output = output + coefficient * s * &
                                   (x ** r) * (y ** (s - 1)) * (z ** t)
                        end if
                      else if (p == 2) then
                        if (t .NE. 0) then
                          output = output + coefficient * t * &
                                   (x ** r) * (y ** s) * (z ** (t - 1))
                        end if
                      end if
                    end do
                  end do
                end do
              end do
            end do
          end do
        term6 = (ii) ** m
        output = term1 * term2 * term6 * output
        output = output / sqrt(4.0d0 * pi / 3.0d0)
        end subroutine calculate_z_prime

        subroutine calculate_q(nu, k, l, factorial, length, output)
        implicit none
        integer::  nu, k, l, length
        double precision, dimension(length)::  factorial
        double precision::  output, b1, b2, b3, b4
!f2py   intent(in)::  nu, k, l, factorial
!f2py   intent(out)::  output

        call binomial(float(k), float(nu), factorial, length, b1)
        call binomial(float(2 * k), float(k), factorial, length, b2)
        call binomial(float(2 * (k + l + nu) + 1), float(2 * k), &
        factorial, length, b3)
        call binomial(float(k + l + nu), float(k), factorial, &
        length, b4)
        output = ((-1.0d0) ** (k + nu)) * &
        sqrt((2.0d0 * l + 4.0d0 * k + 3.0d0) / 3.0d0) * b1 * b2 * &
          b3 / b4 / (2.0d0 ** (2.0d0 * k))
        end subroutine calculate_q

        subroutine binomial(n, k, factorial, length, output)
        implicit none
        real(4)::  n, k
        integer::  length
        double precision, dimension(length)::  factorial
        double precision::  output
!f2py   intent(in)::  n, k, factorial, length
!f2py   intent(out)::  output
        output = factorial(INT(2 * n) + 1) / &
        factorial(INT(2 * k) + 1) / &
        factorial(INT(2 * (n - k)) + 1)
        end subroutine binomial

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

       subroutine calculate_g2(neighbornumbers, neighborpositions, &
       g_number, g_eta, p_gamma, rc, offset, cutofffn_code, ri, &
       num_neighbors, ridge)

              use cutoffs
              implicit none
              integer:: num_neighbors
              integer, dimension(num_neighbors):: neighbornumbers
              integer:: g_number
              double precision, dimension(num_neighbors, 3):: &
              neighborpositions
              double precision, dimension(3):: ri
              double precision::  g_eta, rc, offset
              ! gamma parameter for the polynomial cutoff
              double precision, optional:: p_gamma
              integer:: cutofffn_code
              double precision:: ridge
!f2py         intent(in):: neighbornumbers, neighborpositions, g_number
!f2py         intent(in):: g_eta, rc, ri, p_gamma
!f2py         intent(hide):: num_neighbors
!f2py         intent(out):: ridge
              integer:: j, match, xyz
              double precision, dimension(3):: Rij_vector
              double precision:: Rij, term

              ridge = 0.0d0
              do j = 1, num_neighbors
                  match = compare(neighbornumbers(j), g_number)
                  if (match == 1) then
                    do xyz = 1, 3
                      Rij_vector(xyz) = &
                      neighborpositions(j, xyz) - ri(xyz)
                    end do
                    Rij = sqrt(dot_product(Rij_vector, Rij_vector))
                    term = exp(-g_eta*((Rij - offset)**2.0d0) / (rc ** 2.0d0))
                    if (present(p_gamma)) then
                        term = term * cutoff_fxn(Rij, rc, &
                            cutofffn_code, p_gamma)
                    else
                        term = term * cutoff_fxn(Rij, rc, cutofffn_code)
                    endif
                    ridge = ridge + term
                  end if
              end do

      CONTAINS

      function compare(try, val) result(match)
!     Returns 1 if try is the same set as val, 0 if not.
              implicit none
              integer, intent(in):: try, val
              integer:: match
              if (try == val) then
                      match = 1
              else
                      match = 0
              end if
      end function compare

      end subroutine calculate_g2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine calculate_g4(neighbornumbers, neighborpositions, &
      g_numbers, g_gamma, g_zeta, g_eta, rc, cutofffn_code, ri, &
      num_neighbors, ridge, p_gamma)

              use cutoffs
              implicit none
              integer:: num_neighbors
              integer, dimension(num_neighbors):: neighbornumbers
              integer, dimension(2):: g_numbers
              double precision, dimension(num_neighbors, 3):: &
              neighborpositions
              double precision, dimension(3):: ri
              double precision:: g_gamma, g_zeta, g_eta, rc
              ! gamma parameter for the polynomial cutoff
              double precision, optional:: p_gamma
              integer:: cutofffn_code
              double precision:: ridge
!f2py         intent(in):: neighbornumbers, neighborpositions
!f2py         intent(in):: g_numbers, g_gamma, g_zeta
!f2py         intent(in):: g_eta, rc, ri, p_gamma
!f2py         intent(hide):: num_neighbors
!f2py         intent(out):: ridge
              integer:: j, k, match, xyz
              double precision, dimension(3):: Rij_vector, Rik_vector
              double precision, dimension(3):: Rjk_vector
              double precision:: Rij, Rik, Rjk, costheta, term

              ridge = 0.0d0
              do j = 1, num_neighbors
                do k = (j + 1), num_neighbors
                  match = compare(neighbornumbers(j), &
                  neighbornumbers(k), g_numbers(1), g_numbers(2))
                  if (match == 1) then
                    do xyz = 1, 3
                      Rij_vector(xyz) = &
                      neighborpositions(j, xyz) - ri(xyz)
                      Rik_vector(xyz) = &
                      neighborpositions(k, xyz) - ri(xyz)
                      Rjk_vector(xyz) = &
                      neighborpositions(k, xyz) - &
                      neighborpositions(j, xyz)
                    end do
                    Rij = sqrt(dot_product(Rij_vector, Rij_vector))
                    Rik = sqrt(dot_product(Rik_vector, Rik_vector))
                    Rjk = sqrt(dot_product(Rjk_vector, Rjk_vector))
                    costheta = &
                    dot_product(Rij_vector, Rik_vector) / Rij / Rik
                    if (costheta < -1.0d0) then
                        costheta = -1.0d0
                    end if
                    term = (1.0d0 + g_gamma * costheta)**g_zeta
                    term = term*&
                    exp(-g_eta*(Rij**2 + Rik**2 + Rjk**2)&
                    /(rc ** 2.0d0))
                    if (present(p_gamma)) then
                        term = term*cutoff_fxn(Rij, rc, cutofffn_code, &
                            p_gamma)
                        term = term*cutoff_fxn(Rik, rc, cutofffn_code, &
                            p_gamma)
                        term = term*cutoff_fxn(Rjk, rc, cutofffn_code, &
                            p_gamma)
                    else
                        term = term*cutoff_fxn(Rij, rc, cutofffn_code)
                        term = term*cutoff_fxn(Rik, rc, cutofffn_code)
                        term = term*cutoff_fxn(Rjk, rc, cutofffn_code)
                    endif
                    ridge = ridge + term
                  end if
                end do
              end do
              ridge = ridge * 2.0d0**(1.0d0 - g_zeta)


      CONTAINS

      function compare(try1, try2, val1, val2) result(match)
!     Returns 1 if (try1, try2) is the same set as (val1, val2), 0 if not.
              implicit none
              integer, intent(in):: try1, try2, val1, val2
              integer:: match
              integer:: ntry1, ntry2, nval1, nval2
              ! First sort to avoid endless logical loops.
              if (try1 < try2) then
                      ntry1 = try1
                      ntry2 = try2
              else
                      ntry1 = try2
                      ntry2 = try1
              end if
              if (val1 < val2) then
                      nval1 = val1
                      nval2 = val2
              else
                      nval1 = val2
                      nval2 = val1
              end if
              if (ntry1 == nval1 .AND. ntry2 == nval2) then
                      match = 1
              else
                      match = 0
              end if
      end function compare

      end subroutine calculate_g4

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine calculate_g5(neighbornumbers, neighborpositions, &
      g_numbers, g_gamma, g_zeta, g_eta, rc, cutofffn_code, ri, &
      num_neighbors, ridge, p_gamma)

              use cutoffs
              implicit none
              integer:: num_neighbors
              integer, dimension(num_neighbors):: neighbornumbers
              integer, dimension(2):: g_numbers
              double precision, dimension(num_neighbors, 3):: &
              neighborpositions
              double precision, dimension(3):: ri
              double precision:: g_gamma, g_zeta, g_eta, rc
              ! gamma parameter for the polynomial cutoff
              double precision, optional:: p_gamma
              integer:: cutofffn_code
              double precision:: ridge
!f2py         intent(in):: neighbornumbers, neighborpositions
!f2py         intent(in):: g_numbers, g_gamma, g_zeta
!f2py         intent(in):: g_eta, rc, ri, p_gamma
!f2py         intent(hide):: num_neighbors
!f2py         intent(out):: ridge
              integer:: j, k, match, xyz
              double precision, dimension(3):: Rij_vector, Rik_vector
              double precision:: Rij, Rik, costheta, term

              ridge = 0.0d0
              do j = 1, num_neighbors
                do k = (j + 1), num_neighbors
                  match = compare(neighbornumbers(j), &
                  neighbornumbers(k), g_numbers(1), g_numbers(2))
                  if (match == 1) then
                    do xyz = 1, 3
                      Rij_vector(xyz) = &
                      neighborpositions(j, xyz) - ri(xyz)
                      Rik_vector(xyz) = &
                      neighborpositions(k, xyz) - ri(xyz)
                    end do
                    Rij = sqrt(dot_product(Rij_vector, Rij_vector))
                    Rik = sqrt(dot_product(Rik_vector, Rik_vector))
                    costheta = &
                    dot_product(Rij_vector, Rik_vector) / Rij / Rik
                    if (costheta < -1.0d0) then
                        costheta = -1.0d0
                    end if
                    term = (1.0d0 + g_gamma * costheta)**g_zeta
                    term = term*&
                    exp(-g_eta*(Rij**2 + Rik**2)&
                    /(rc ** 2.0d0))
                    if (present(p_gamma)) then
                        term = term*cutoff_fxn(Rij, rc, cutofffn_code, &
                            p_gamma)
                        term = term*cutoff_fxn(Rik, rc, cutofffn_code, &
                            p_gamma)
                    else
                        term = term*cutoff_fxn(Rij, rc, cutofffn_code)
                        term = term*cutoff_fxn(Rik, rc, cutofffn_code)
                    end if
                    ridge = ridge + term
                  end if
                end do
              end do
              ridge = ridge * 2.0d0**(1.0d0 - g_zeta)

      CONTAINS

      function compare(try1, try2, val1, val2) result(match)
!     Returns 1 if (try1, try2) is the same set as (val1, val2), 0 if not.
              implicit none
              integer, intent(in):: try1, try2, val1, val2
              integer:: match
              integer:: ntry1, ntry2, nval1, nval2
              ! First sort to avoid endless logical loops.
              if (try1 < try2) then
                      ntry1 = try1
                      ntry2 = try2
              else
                      ntry1 = try2
                      ntry2 = try1
              end if
              if (val1 < val2) then
                      nval1 = val1
                      nval2 = val2
              else
                      nval1 = val2
                      nval2 = val1
              end if
              if (ntry1 == nval1 .AND. ntry2 == nval2) then
                      match = 1
              else
                      match = 0
              end if
      end function compare

      end subroutine calculate_g5

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

       subroutine calculate_g2_prime(neighborindices, neighbornumbers, &
       neighborpositions, g_number, g_eta, rc, cutofffn_code, i, ri, m, l, &
       offset, num_neighbors, ridge, p_gamma)

              use cutoffs
              implicit none
              integer:: num_neighbors
              integer, dimension(num_neighbors):: neighborindices
              integer, dimension(num_neighbors):: neighbornumbers
              integer:: g_number
              double precision, dimension(num_neighbors, 3):: &
              neighborpositions
              double precision, dimension(3):: ri, Rj
              integer:: m, l, i
              double precision::  g_eta, rc, offset
              ! gamma parameter for the polynomial cutoff
              double precision, optional:: p_gamma
              integer:: cutofffn_code
              double precision:: ridge
!f2py         intent(in):: neighborindices, neighbornumbers
!f2py         intent(in):: neighborpositions, g_number
!f2py         intent(in):: g_eta, rc, i, ri, m, l, p_gamma
!f2py         intent(hide):: num_neighbors
!f2py         intent(out):: ridge
              integer:: j, match, xyz
              double precision, dimension(3):: Rij_vector
              double precision:: Rij, term1, dRijdRml

              ridge = 0.0d0
              do j = 1, num_neighbors
                  match = compare(neighbornumbers(j), g_number)
                  if (match == 1) then
                    do xyz = 1, 3
                      Rj(xyz) = neighborpositions(j, xyz)
                      Rij_vector(xyz) = Rj(xyz) - ri(xyz)
                    end do
                    dRijdRml = &
                     dRij_dRml(i, neighborindices(j), ri, Rj, m, l)
                    if (dRijdRml /= 0.0d0) then
                        Rij = sqrt(dot_product(Rij_vector, Rij_vector))

                        if (present(p_gamma)) then
                            term1 = - 2.0d0 * g_eta * (Rij - offset) * &
                            cutoff_fxn(Rij, rc, cutofffn_code, p_gamma) / &
                            (rc ** 2.0d0) + cutoff_fxn_prime(Rij, rc, &
                            cutofffn_code, p_gamma)
                        else
                            term1 = - 2.0d0 * g_eta * (Rij - offset) * &
                            cutoff_fxn(Rij, rc, cutofffn_code) / &
                            (rc ** 2.0d0) + cutoff_fxn_prime(Rij, rc, &
                            cutofffn_code)
                        endif

                        ridge = ridge + &
                        exp(- g_eta * ((Rij - offset)**2.0d0) / &
                        (rc ** 2.0d0)) * term1 * dRijdRml
                    end if
                  end if
              end do

      CONTAINS

      function compare(try, val) result(match)
!     Returns 1 if try is the same set as val, 0 if not.
              implicit none
              integer, intent(in):: try, val
              integer:: match
              if (try == val) then
                      match = 1
              else
                      match = 0
              end if
      end function compare


      function dRij_dRml(i, j, Ri, Rj, m, l)
              integer i, j, m, l
              double precision, dimension(3):: Ri, Rj, Rij_vector
              double precision:: dRij_dRml, Rij
              do xyz = 1, 3
                      Rij_vector(xyz) = Rj(xyz) - Ri(xyz)
              end do
              Rij = sqrt(dot_product(Rij_vector, Rij_vector))
              if ((m == i) .AND. (i /= j)) then
                      dRij_dRml = - (Rj(l + 1) - Ri(l + 1)) / Rij
              else if ((m == j) .AND. (i /= j)) then
                      dRij_dRml = (Rj(l + 1) - Ri(l + 1)) / Rij
              else
                      dRij_dRml = 0.0d0
              end if
      end function

      end subroutine calculate_g2_prime

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine calculate_g4_prime(neighborindices, neighbornumbers, &
      neighborpositions, g_numbers, g_gamma, g_zeta, g_eta, rc, &
      cutofffn_code, i, ri, m, l, num_neighbors, ridge, p_gamma)

              use cutoffs
              implicit none
              integer:: num_neighbors
              integer, dimension(num_neighbors):: neighborindices
              integer, dimension(num_neighbors):: neighbornumbers
              integer, dimension(2):: g_numbers
              double precision, dimension(num_neighbors, 3):: &
              neighborpositions
              double precision, dimension(3):: ri, Rj, Rk
              integer:: i, m, l
              double precision:: g_gamma, g_zeta, g_eta, rc
              ! gamma parameter for the polynomial cutoff
              double precision, optional:: p_gamma
              integer:: cutofffn_code
              double precision:: ridge
!f2py         intent(in):: neighbornumbers, neighborpositions
!f2py         intent(in):: g_numbers, g_gamma, g_zeta, p_gamma
!f2py         intent(in):: g_eta, rc, ri, neighborindices , i, m, l
!f2py         intent(hide):: num_neighbors
!f2py         intent(out):: ridge
              integer:: j, k, match, xyz
              double precision, dimension(3):: Rij_vector, Rik_vector
              double precision, dimension(3):: Rjk_vector
              double precision:: Rij, Rik, Rjk, costheta
              double precision:: c1, fcRij, fcRik, fcRjk
              double precision:: fcRijfcRikfcRjk, dCosthetadRml
              double precision:: dRijdRml, dRikdRml, dRjkdRml
              double precision:: term1, term2, term3, term4, term5
              double precision:: term6

              ridge = 0.0d0
              do j = 1, num_neighbors
                do k = (j + 1), num_neighbors
                  match = compare(neighbornumbers(j), &
                  neighbornumbers(k), g_numbers(1), g_numbers(2))
                  if (match == 1) then
                    do xyz = 1, 3
                      Rj(xyz) = neighborpositions(j, xyz)
                      Rk(xyz) = neighborpositions(k, xyz)
                      Rij_vector(xyz) = Rj(xyz) - ri(xyz)
                      Rik_vector(xyz) = Rk(xyz) - ri(xyz)
                      Rjk_vector(xyz) = Rk(xyz) - Rj(xyz)
                    end do
                    Rij = sqrt(dot_product(Rij_vector, Rij_vector))
                    Rik = sqrt(dot_product(Rik_vector, Rik_vector))
                    Rjk = sqrt(dot_product(Rjk_vector, Rjk_vector))
                    costheta = &
                    dot_product(Rij_vector, Rik_vector) / Rij / Rik
                    if (costheta < -1.0d0) then
                        costheta = -1.0d0
                    end if
                    c1 = (1.0d0 + g_gamma * costheta)
                    if (present(p_gamma)) then
                        fcRij = cutoff_fxn(Rij, rc, cutofffn_code, p_gamma)
                        fcRik = cutoff_fxn(Rik, rc, cutofffn_code, p_gamma)
                        fcRjk = cutoff_fxn(Rjk, rc, cutofffn_code, p_gamma)
                    else
                        fcRij = cutoff_fxn(Rij, rc, cutofffn_code)
                        fcRik = cutoff_fxn(Rik, rc, cutofffn_code)
                        fcRjk = cutoff_fxn(Rjk, rc, cutofffn_code)
                    endif


                    if (g_zeta == 1.0d0) then
                        term1 = exp(-g_eta*(Rij**2 + Rik**2 + Rjk**2)&
                        / (rc ** 2.0d0))
                    else
                        term1 = (c1**(g_zeta - 1.0d0)) &
                             * exp(-g_eta*(Rij**2 + Rik**2 + Rjk**2)&
                             / (rc ** 2.0d0))
                    end if
                    term2 = 0.d0
                    fcRijfcRikfcRjk = fcRij * fcRik * fcRjk
                    dCosthetadRml = &
                    dCos_ijk_dR_ml(i, neighborindices(j), &
                    neighborindices(k), ri, Rj, Rk, m, l)
                    if (dCosthetadRml /= 0.d0) then
                      term2 = term2 + g_gamma * g_zeta * dCosthetadRml
                    end if
                    dRijdRml = &
                    dRij_dRml(i, neighborindices(j), ri, Rj, m, l)
                    if (dRijdRml /= 0.0d0) then
                        term2 = &
                        term2 - 2.0d0 * c1 * g_eta * Rij * dRijdRml &
                        / (rc ** 2.0d0)
                    end if
                    dRikdRml = &
                    dRij_dRml(i, neighborindices(k), ri, Rk, m, l)
                    if (dRikdRml /= 0.0d0) then
                        term2 = &
                        term2 - 2.0d0 * c1 * g_eta * Rik * dRikdRml &
                        / (rc ** 2.0d0)
                    end if
                    dRjkdRml =  &
                    dRij_dRml(neighborindices(j), neighborindices(k), &
                    Rj, Rk, m, l)
                    if (dRjkdRml /= 0.0d0) then
                        term2 = &
                        term2 - 2.0d0 * c1 * g_eta * Rjk * dRjkdRml &
                        / (rc ** 2.0d0)
                    end if
                    term3 = fcRijfcRikfcRjk * term2

                    if (present(p_gamma)) then
                        term4 = &
                        cutoff_fxn_prime(Rij, rc, cutofffn_code, p_gamma) &
                        * dRijdRml * fcRik * fcRjk
                        term5 = &
                        fcRij * cutoff_fxn_prime(Rik, rc, cutofffn_code, &
                        p_gamma) * dRikdRml * fcRjk
                        term6 = &
                        fcRij * fcRik * cutoff_fxn_prime(Rjk, rc, &
                        cutofffn_code, p_gamma) * dRjkdRml
                    else
                        term4 = &
                        cutoff_fxn_prime(Rij, rc, cutofffn_code) &
                        * dRijdRml * fcRik * fcRjk
                        term5 = &
                        fcRij * cutoff_fxn_prime(Rik, rc, cutofffn_code) &
                        * dRikdRml * fcRjk
                        term6 = &
                        fcRij * fcRik * cutoff_fxn_prime(Rjk, rc, &
                        cutofffn_code) * dRjkdRml
                    endif
                    ridge = ridge + &
                    term1 * (term3 + c1 * (term4 + term5 + term6))
                  end if
                end do
              end do
              ridge = ridge * (2.0d0**(1.0d0 - g_zeta))

      CONTAINS

      function compare(try1, try2, val1, val2) result(match)
!     Returns 1 if (try1, try2) is the same set as (val1, val2), 0 if not.
              implicit none
              integer, intent(in):: try1, try2, val1, val2
              integer:: match
              integer:: ntry1, ntry2, nval1, nval2
              ! First sort to avoid endless logical loops.
              if (try1 < try2) then
                      ntry1 = try1
                      ntry2 = try2
              else
                      ntry1 = try2
                      ntry2 = try1
              end if
              if (val1 < val2) then
                      nval1 = val1
                      nval2 = val2
              else
                      nval1 = val2
                      nval2 = val1
              end if
              if (ntry1 == nval1 .AND. ntry2 == nval2) then
                      match = 1
              else
                      match = 0
              end if
      end function compare

      function dRij_dRml(i, j, Ri, Rj, m, l)
              integer i, j, m, l
              double precision, dimension(3):: Ri, Rj, Rij_vector
              double precision:: dRij_dRml, Rij
              do xyz = 1, 3
                      Rij_vector(xyz) = Rj(xyz) - Ri(xyz)
              end do
              Rij = sqrt(dot_product(Rij_vector, Rij_vector))
              if ((m == i) .AND. (i /= j)) then
                      dRij_dRml = - (Rj(l + 1) - Ri(l + 1)) / Rij
              else if ((m == j) .AND. (i /= j)) then
                      dRij_dRml = (Rj(l + 1) - Ri(l + 1)) / Rij
              else
                      dRij_dRml = 0.0d0
              end if
      end function

      function dCos_ijk_dR_ml(i, j, k, ri, Rj, Rk, m, l)
      implicit none
      integer:: i, j, k, m, l
      double precision:: dCos_ijk_dR_ml
      double precision, dimension(3):: ri, Rj, Rk
      integer, dimension(3):: dRijdRml, dRikdRml
      double precision:: dRijdRml_, dRikdRml_

      do xyz = 1, 3
            Rij_vector(xyz) = Rj(xyz) - ri(xyz)
            Rik_vector(xyz) = Rk(xyz) - ri(xyz)
      end do
      Rij = sqrt(dot_product(Rij_vector, Rij_vector))
      Rik = sqrt(dot_product(Rik_vector, Rik_vector))
      dCos_ijk_dR_ml = 0.0d0

      dRijdRml = dRij_dRml_vector(i, j, m, l)
      if ((dRijdRml(1) /= 0) .OR. (dRijdRml(2) /= 0) .OR. &
      (dRijdRml(3) /= 0)) then
        dCos_ijk_dR_ml = dCos_ijk_dR_ml + 1.0d0 / (Rij * Rik) * &
        dot_product(dRijdRml, Rik_vector)
      end if

      dRikdRml = dRij_dRml_vector(i, k, m, l)
      if ((dRikdRml(1) /= 0) .OR. (dRikdRml(2) /= 0) .OR. &
      (dRikdRml(3) /= 0)) then
        dCos_ijk_dR_ml =  dCos_ijk_dR_ml + 1.0d0 / (Rij * Rik) * &
        dot_product(dRikdRml, Rij_vector)
      end if

      dRijdRml_ = dRij_dRml(i, j, ri, Rj, m, l)
      if (dRijdRml_ /= 0.0d0) then
        dCos_ijk_dR_ml =  dCos_ijk_dR_ml - 1.0d0 / (Rij * Rij * Rik) * &
        dot_product(Rij_vector, Rik_vector) * dRijdRml_
      end if

      dRikdRml_ = dRij_dRml(i, k, ri, Rk, m, l)
      if (dRikdRml_ /= 0.0d0) then
        dCos_ijk_dR_ml =  dCos_ijk_dR_ml - 1.0d0 / (Rij * Rik * Rik) * &
        dot_product(Rij_vector, Rik_vector) * dRikdRml_
      end if

      end function

      function dRij_dRml_vector(i, j, m, l)
      implicit none
      integer:: i, j, m, l, c1
      integer, dimension(3):: dRij_dRml_vector

      if ((m /= i) .AND. (m /= j)) then
          dRij_dRml_vector(1) = 0
          dRij_dRml_vector(2) = 0
          dRij_dRml_vector(3) = 0
      else
          c1 = Kronecker(m, j) - Kronecker(m, i)
          dRij_dRml_vector(1) = c1 * Kronecker(0, l)
          dRij_dRml_vector(2) = c1 * Kronecker(1, l)
          dRij_dRml_vector(3) = c1 * Kronecker(2, l)
      end if

      end function

      function Kronecker(i, j)
      implicit none
      integer:: i, j
      integer:: Kronecker

      if (i == j) then
        Kronecker = 1
      else
        Kronecker = 0
      end if

      end function

      end subroutine calculate_g4_prime

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine calculate_g5_prime(neighborindices, neighbornumbers, &
      neighborpositions, g_numbers, g_gamma, g_zeta, g_eta, rc, &
      cutofffn_code, i, ri, m, l, num_neighbors, ridge, p_gamma)

              use cutoffs
              implicit none
              integer:: num_neighbors
              integer, dimension(num_neighbors):: neighborindices
              integer, dimension(num_neighbors):: neighbornumbers
              integer, dimension(2):: g_numbers
              double precision, dimension(num_neighbors, 3):: &
              neighborpositions
              double precision, dimension(3):: ri, Rj, Rk
              integer:: i, m, l
              double precision:: g_gamma, g_zeta, g_eta, rc
              ! gamma parameter for the polynomial cutoff
              double precision, optional:: p_gamma
              integer:: cutofffn_code
              double precision:: ridge
!f2py         intent(in):: neighbornumbers, neighborpositions
!f2py         intent(in):: g_numbers, g_gamma, g_zeta, p_gamma
!f2py         intent(in):: g_eta, rc, ri, neighborindices , i, m, l
!f2py         intent(hide):: num_neighbors
!f2py         intent(out):: ridge
              integer:: j, k, match, xyz
              double precision, dimension(3):: Rij_vector, Rik_vector
              double precision:: Rij, Rik, costheta
              double precision:: c1, fcRij, fcRik
              double precision:: fcRijfcRik, dCosthetadRml
              double precision:: dRijdRml, dRikdRml
              double precision:: term1, term2, term3, term4, term5

              ridge = 0.0d0
              do j = 1, num_neighbors
                do k = (j + 1), num_neighbors
                  match = compare(neighbornumbers(j), &
                  neighbornumbers(k), g_numbers(1), g_numbers(2))
                  if (match == 1) then
                    do xyz = 1, 3
                      Rj(xyz) = neighborpositions(j, xyz)
                      Rk(xyz) = neighborpositions(k, xyz)
                      Rij_vector(xyz) = Rj(xyz) - ri(xyz)
                      Rik_vector(xyz) = Rk(xyz) - ri(xyz)
                    end do
                    Rij = sqrt(dot_product(Rij_vector, Rij_vector))
                    Rik = sqrt(dot_product(Rik_vector, Rik_vector))
                    costheta = &
                    dot_product(Rij_vector, Rik_vector) / Rij / Rik
                    if (costheta < -1.0d0) then
                        costheta = -1.0d0
                    end if
                    c1 = (1.0d0 + g_gamma * costheta)
                    if (present(p_gamma)) then
                        fcRij = cutoff_fxn(Rij, rc, cutofffn_code, p_gamma)
                        fcRik = cutoff_fxn(Rik, rc, cutofffn_code, p_gamma)
                    else
                        fcRij = cutoff_fxn(Rij, rc, cutofffn_code)
                        fcRik = cutoff_fxn(Rik, rc, cutofffn_code)
                    endif

                    if (g_zeta == 1.0d0) then
                        term1 = exp(-g_eta*(Rij**2 + Rik**2)&
                        / (rc ** 2.0d0))
                    else
                        term1 = (c1**(g_zeta - 1.0d0)) &
                             * exp(-g_eta*(Rij**2 + Rik**2)&
                             / (rc ** 2.0d0))
                    end if
                    term2 = 0.d0
                    fcRijfcRik = fcRij * fcRik
                    dCosthetadRml = &
                    dCos_ijk_dR_ml(i, neighborindices(j), &
                    neighborindices(k), ri, Rj, Rk, m, l)
                    if (dCosthetadRml /= 0.d0) then
                      term2 = term2 + g_gamma * g_zeta * dCosthetadRml
                    end if
                    dRijdRml = &
                    dRij_dRml(i, neighborindices(j), ri, Rj, m, l)
                    if (dRijdRml /= 0.0d0) then
                        term2 = &
                        term2 - 2.0d0 * c1 * g_eta * Rij * dRijdRml &
                        / (rc ** 2.0d0)
                    end if
                    dRikdRml = &
                    dRij_dRml(i, neighborindices(k), ri, Rk, m, l)
                    if (dRikdRml /= 0.0d0) then
                        term2 = &
                        term2 - 2.0d0 * c1 * g_eta * Rik * dRikdRml &
                        / (rc ** 2.0d0)
                    end if

                    term3 = fcRijfcRik * term2

                    if(present(p_gamma)) then
                        term4 = &
                        cutoff_fxn_prime(Rij, rc, cutofffn_code, p_gamma) &
                        * dRijdRml * fcRik
                        term5 = &
                        fcRij * cutoff_fxn_prime(Rik, rc, cutofffn_code, &
                        p_gamma) * dRikdRml
                    else
                        term4 = &
                        cutoff_fxn_prime(Rij, rc, cutofffn_code) &
                        * dRijdRml * fcRik
                        term5 = &
                        fcRij * cutoff_fxn_prime(Rik, rc, cutofffn_code) &
                        * dRikdRml
                    end if
                    ridge = ridge + &
                    term1 * (term3 + c1 * (term4 + term5))
                  end if
                end do
              end do
              ridge = ridge * (2.0d0**(1.0d0 - g_zeta))

      CONTAINS

      function compare(try1, try2, val1, val2) result(match)
!     Returns 1 if (try1, try2) is the same set as (val1, val2), 0 if not.
              implicit none
              integer, intent(in):: try1, try2, val1, val2
              integer:: match
              integer:: ntry1, ntry2, nval1, nval2
              ! First sort to avoid endless logical loops.
              if (try1 < try2) then
                      ntry1 = try1
                      ntry2 = try2
              else
                      ntry1 = try2
                      ntry2 = try1
              end if
              if (val1 < val2) then
                      nval1 = val1
                      nval2 = val2
              else
                      nval1 = val2
                      nval2 = val1
              end if
              if (ntry1 == nval1 .AND. ntry2 == nval2) then
                      match = 1
              else
                      match = 0
              end if
      end function compare

      function dRij_dRml(i, j, Ri, Rj, m, l)
              integer i, j, m, l
              double precision, dimension(3):: Ri, Rj, Rij_vector
              double precision:: dRij_dRml, Rij
              do xyz = 1, 3
                      Rij_vector(xyz) = Rj(xyz) - Ri(xyz)
              end do
              Rij = sqrt(dot_product(Rij_vector, Rij_vector))
              if ((m == i) .AND. (i /= j)) then
                      dRij_dRml = - (Rj(l + 1) - Ri(l + 1)) / Rij
              else if ((m == j) .AND. (i /= j)) then
                      dRij_dRml = (Rj(l + 1) - Ri(l + 1)) / Rij
              else
                      dRij_dRml = 0.0d0
              end if
      end function

      function dCos_ijk_dR_ml(i, j, k, ri, Rj, Rk, m, l)
      implicit none
      integer:: i, j, k, m, l
      double precision:: dCos_ijk_dR_ml
      double precision, dimension(3):: ri, Rj, Rk
      integer, dimension(3):: dRijdRml, dRikdRml
      double precision:: dRijdRml_, dRikdRml_

      do xyz = 1, 3
            Rij_vector(xyz) = Rj(xyz) - ri(xyz)
            Rik_vector(xyz) = Rk(xyz) - ri(xyz)
      end do
      Rij = sqrt(dot_product(Rij_vector, Rij_vector))
      Rik = sqrt(dot_product(Rik_vector, Rik_vector))
      dCos_ijk_dR_ml = 0.0d0

      dRijdRml = dRij_dRml_vector(i, j, m, l)
      if ((dRijdRml(1) /= 0) .OR. (dRijdRml(2) /= 0) .OR. &
      (dRijdRml(3) /= 0)) then
        dCos_ijk_dR_ml = dCos_ijk_dR_ml + 1.0d0 / (Rij * Rik) * &
        dot_product(dRijdRml, Rik_vector)
      end if

      dRikdRml = dRij_dRml_vector(i, k, m, l)
      if ((dRikdRml(1) /= 0) .OR. (dRikdRml(2) /= 0) .OR. &
      (dRikdRml(3) /= 0)) then
        dCos_ijk_dR_ml =  dCos_ijk_dR_ml + 1.0d0 / (Rij * Rik) * &
        dot_product(dRikdRml, Rij_vector)
      end if

      dRijdRml_ = dRij_dRml(i, j, ri, Rj, m, l)
      if (dRijdRml_ /= 0.0d0) then
        dCos_ijk_dR_ml =  dCos_ijk_dR_ml - 1.0d0 / (Rij * Rij * Rik) * &
        dot_product(Rij_vector, Rik_vector) * dRijdRml_
      end if

      dRikdRml_ = dRij_dRml(i, k, ri, Rk, m, l)
      if (dRikdRml_ /= 0.0d0) then
        dCos_ijk_dR_ml =  dCos_ijk_dR_ml - 1.0d0 / (Rij * Rik * Rik) * &
        dot_product(Rij_vector, Rik_vector) * dRikdRml_
      end if

      end function

      function dRij_dRml_vector(i, j, m, l)
      implicit none
      integer:: i, j, m, l, c1
      integer, dimension(3):: dRij_dRml_vector

      if ((m /= i) .AND. (m /= j)) then
          dRij_dRml_vector(1) = 0
          dRij_dRml_vector(2) = 0
          dRij_dRml_vector(3) = 0
      else
          c1 = Kronecker(m, j) - Kronecker(m, i)
          dRij_dRml_vector(1) = c1 * Kronecker(0, l)
          dRij_dRml_vector(2) = c1 * Kronecker(1, l)
          dRij_dRml_vector(3) = c1 * Kronecker(2, l)
      end if

      end function

      function Kronecker(i, j)
      implicit none
      integer:: i, j
      integer:: Kronecker

      if (i == j) then
        Kronecker = 1
      else
        Kronecker = 0
      end if

      end function

      end subroutine calculate_g5_prime

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      module cutoffs
          implicit none

          contains
      function cutoff_fxn(r, rc, cutofffn_code, p_gamma)
          double precision:: r, rc, pi, cutoff_fxn
          ! gamma parameter for the polynomial cutoff
          double precision, optional:: p_gamma
          integer:: cutofffn_code

          ! To avoid noise, for each call of this function, it is better to
          ! set returned variables to 0.0d0.
          cutoff_fxn = 0.0d0

          if (r < rc) then
              if (cutofffn_code == 1) then
                  pi = 4.0d0 * datan(1.0d0)
                  cutoff_fxn = 0.5d0 * (cos(pi*r/rc) + 1.0d0)
              elseif (cutofffn_code == 2) then
                  cutoff_fxn = 1. + p_gamma &
                      * (r / rc) ** (p_gamma + 1) &
                      - (p_gamma + 1) * (r / rc) ** p_gamma
              end if
          end if
      end function cutoff_fxn

      function cutoff_fxn_prime(r, rc, cutofffn_code, p_gamma)
          double precision:: r, rc, cutoff_fxn_prime, pi
          ! gamma parameter for the polynomial cutoff
          double precision, optional:: p_gamma
          integer:: cutofffn_code

          ! To avoid noise, for each call of this function, it is better to
          ! set returned variables to 0.0d0.
          cutoff_fxn_prime = 0.0d0

          if (r < rc) then
              if (cutofffn_code == 1) then
                  pi = 4.0d0 * datan(1.0d0)
                  cutoff_fxn_prime = -0.5d0 * pi * sin(pi*r/rc) / rc
              elseif (cutofffn_code == 2) then
                  cutoff_fxn_prime = (p_gamma * (p_gamma + 1) / rc) &
                   * ((r / rc) ** p_gamma - (r / rc) ** (p_gamma - 1))
              end if
          end if
      end function cutoff_fxn_prime

      end module cutoffs

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!     Fortran Version = 14
      subroutine check_version(version, warning)
      implicit none

      integer::  version, warning
!f2py         intent(in)::  version
!f2py         intent(out)::  warning
      if (version .NE. 14) then
          warning = 1
      else
          warning = 0
      end if
      end subroutine

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     module containing all the data of fingerprints (should be fed in
!     by python)
      module fingerprint_props
      implicit none

      integer, allocatable:: num_fingerprints_of_elements(:)
      double precision, allocatable:: raveled_fingerprints(:, :)
      double precision, allocatable:: raveled_fingerprintprimes(:, :)

      end module fingerprint_props

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     module containing model data (should be fed in by python)
      module model_props
      implicit none
      ! mode_signal is 1 for image-centered mode, and 2 for
      ! atom-centered mode
      integer:: mode_signal
      logical:: train_forces
      double precision:: energy_coefficient
      double precision:: force_coefficient
      double precision:: overfit
      logical:: numericprime
      double precision:: d

      end module model_props

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     module containing all the data of images (should be fed in by
!     python)
      module images_props
      implicit none

      integer:: num_images
!     atom-centered variables
      integer:: num_elements
      integer, allocatable:: elements_numbers(:)
      integer, allocatable:: num_images_atoms(:)
      integer, allocatable:: atomic_numbers(:)
      integer, allocatable:: num_neighbors(:)
      integer, allocatable:: raveled_neighborlists(:)
      integer, allocatable:: is_nft(:)
      integer, allocatable:: nft_indices(:)
      double precision, allocatable:: actual_energies(:)
      double precision, allocatable:: image_weights(:)
      double precision, allocatable:: actual_forces(:, :)
!     image-centered variables
      integer:: num_atoms
      double precision, allocatable:: atomic_positions(:, :)

      end module images_props

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     subroutine that calculates the loss function and its prime
      subroutine calculate_loss(parameters, num_parameters, overfit_mask, &
      lossprime, loss, dloss_dparameters, energyloss, forceloss, &
      energy_maxresid, force_maxresid)

      use images_props
      use fingerprint_props
      use model_props
      use neuralnetwork

!!!!!!!!!!!!!!!!!!!!!!!! input/output variables !!!!!!!!!!!!!!!!!!!!!!!!

      integer:: num_parameters
      double precision:: parameters(num_parameters)
      logical:: lossprime
      double precision:: loss, energyloss, forceloss
      double precision:: energy_maxresid, force_maxresid
      double precision:: dloss_dparameters(num_parameters)
      double precision:: doverfitloss_dparameters(num_parameters)
      double precision:: image_dldp(num_parameters)
      integer:: overfit_mask(num_parameters)
!f2py         intent(in):: parameters, num_parameters
!f2py         intent(in):: lossprime
!f2py         intent(out):: loss, energyloss, forceloss
!f2py         intent(out):: energy_maxresid, force_maxresid
!f2py         intent(out):: dloss_dparameters

!!!!!!!!!!!!!!!!!!!!!!!!!!! type definition !!!!!!!!!!!!!!!!!!!!!!!!!!!!

      type:: image_forces
        sequence
        double precision, allocatable:: atom_forces(:, :)
      end type image_forces

      type:: integer_one_d_array
        sequence
        integer, allocatable:: onedarray(:)
      end type integer_one_d_array

      type:: embedded_real_one_one_d_array
        sequence
        type(real_one_d_array), allocatable:: onedarray(:)
      end type embedded_real_one_one_d_array

      type:: embedded_real_one_two_d_array
        sequence
        type(real_two_d_array), allocatable:: onedarray(:)
      end type embedded_real_one_two_d_array

      type:: embedded_integer_one_one_d_array
        sequence
        type(integer_one_d_array), allocatable:: onedarray(:)
      end type embedded_integer_one_one_d_array

      type:: embedded_one_one_two_d_array
        sequence
        type(embedded_real_one_two_d_array), allocatable:: onedarray(:)
      end type embedded_one_one_two_d_array

!!!!!!!!!!!!!!!!!!!!!!!!!! dummy variables !!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      double precision, allocatable::  fingerprint(:)
      type(embedded_real_one_one_d_array), allocatable:: &
      unraveled_fingerprints(:)
      type(integer_one_d_array), allocatable:: &
      unraveled_atomic_numbers(:)
      double precision:: amp_energy, actual_energy, atom_energy
      double precision:: image_weight
      double precision:: residual_per_atom, dforce, force_resid
      double precision:: overfitloss, image_forceloss
      integer:: i, index, j, p, k, q, l, m, &
      len_of_fingerprint, symbol, element, image_no, num_inputs
      double precision:: denergy_dparameters(num_parameters)
      double precision:: daenergy_dparameters(num_parameters)
      double precision:: dforce_dparameters(num_parameters)
      type(real_two_d_array), allocatable:: dforces_dparameters(:)
      type(image_forces), allocatable:: unraveled_actual_forces(:)
      type(embedded_integer_one_one_d_array), allocatable:: &
      unraveled_neighborlists(:)
      type(embedded_one_one_two_d_array), allocatable:: &
      unraveled_fingerprintprimes(:)
      double precision, allocatable:: fingerprintprime(:)
      integer:: nindex, nsymbol, selfindex, f_index, nft
      double precision, allocatable:: &
      actual_forces_(:, :), amp_forces(:, :)
      integer, allocatable:: neighborindices(:)
!     image-centered mode
      type(real_one_d_array), allocatable:: &
      unraveled_atomic_positions(:)
      double precision, allocatable::  inputs(:), inputs_(:)

!!!!!!!!!!!!!!!!!!!!!!!!!!!! calculations !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      if (mode_signal == 1) then
        allocate(inputs(3 * num_atoms))
        allocate(inputs_(3 * num_atoms))
        allocate(unraveled_atomic_positions(num_images))
        call unravel_atomic_positions()
      else
        allocate(unraveled_fingerprints(num_images))
        allocate(unraveled_atomic_numbers(num_images))
        allocate(unraveled_neighborlists(num_images))
        allocate(unraveled_fingerprintprimes(num_images))
        call unravel_atomic_numbers()
        call unravel_fingerprints()
      end if
      if (train_forces .EQV. .TRUE.) then
          allocate(unraveled_actual_forces(num_images))
          call unravel_actual_forces()
          if (mode_signal == 2) then
              call unravel_neighborlists()
              call unravel_fingerprintprimes()
          end if
      end if

      energyloss = 0.0d0
      forceloss = 0.0d0
      energy_maxresid = 0.0d0
      force_maxresid = 0.0d0
      do j = 1, num_parameters
        dloss_dparameters(j) = 0.0d0
        doverfitloss_dparameters(j) = 0.0d0
      end do

!     summation over images
      do image_no = 1, num_images
        num_atoms = num_images_atoms(image_no)
        image_weight = image_weights(image_no)
        actual_energy = actual_energies(image_no)
        nft = is_nft(image_no)
        if (nft  == 1) then
          residual_per_atom = 0
        else
          ! calculates amp_energy
          call calculate_energy(image_no)
          ! calculates energy_maxresid
          residual_per_atom = ABS(amp_energy - actual_energy) / num_atoms
        end if
        if (residual_per_atom .GT. energy_maxresid) then
            energy_maxresid = residual_per_atom
        end if
        ! calculates energyloss
        energyloss = energyloss + image_weight * residual_per_atom ** 2.0d0
        if (lossprime .EQV. .TRUE.) then
            ! calculates denergy_dparameters
            if (mode_signal == 1) then ! image-centered mode
                denergy_dparameters = &
                calculate_denergy_dparameters_(num_inputs, inputs, &
                num_parameters, parameters)
            else  ! atom-centered mode
                do j = 1, num_parameters
                    denergy_dparameters(j) = 0.0d0
                end do
                if (nft == 0) then
                  if (numericprime .EQV. .FALSE.) then
                      call calculate_denergy_dparameters(image_no)
                  else
                      call calculate_numerical_denergy_dparameters(image_no)
                  end if
                end if
            end if
            ! calculates contribution of energyloss to dloss_dparameters
            if (nft == 0) then
              do j = 1, num_parameters
                  dloss_dparameters(j) = dloss_dparameters(j) + &
                  image_weight * &
                  energy_coefficient *  2.0d0 * &
                  (amp_energy - actual_energy) * &
                  denergy_dparameters(j) / (num_atoms ** 2.0d0)
              end do
            end if
        end if
        if (train_forces .EQV. .TRUE.) then
            allocate(actual_forces_(num_atoms, 3))
            do selfindex = 1, num_atoms
                do i = 1, 3
                    actual_forces_(selfindex, i) = &
                    unraveled_actual_forces(&
                    image_no)%atom_forces(selfindex, i)
                end do
            end do
            ! calculates amp_forces
            call calculate_forces(image_no)
            ! calculates forceloss and force_maxresid
            image_forceloss = 0.0d0
            if (nft == 1) then
              f_index = nft_indices(image_no) + 1
              do i = 1, 3
                force_resid = ABS(amp_forces(f_index, i) - &
                actual_forces_(f_index, i))
                if (force_resid .GT. force_maxresid) then
                    force_maxresid = force_resid
                end if
                image_forceloss = image_forceloss + force_resid ** 2.0d0
              end do
              image_forceloss = image_forceloss / 3.0d0
            else
              do selfindex = 1, num_atoms
                  do i = 1, 3
                      force_resid = ABS(amp_forces(selfindex, i) - &
                      actual_forces_(selfindex, i))
                      if (force_resid .GT. force_maxresid) then
                          force_maxresid = force_resid
                      end if
                      image_forceloss = image_forceloss + force_resid ** 2.0d0
                  end do
              end do
              image_forceloss = image_forceloss / 3.0d0 / num_atoms
            end if
            forceloss = forceloss + image_weight * image_forceloss

            if (lossprime .EQV. .TRUE.) then
                allocate(dforces_dparameters(num_atoms))
                do selfindex = 1, num_atoms
                    allocate(dforces_dparameters(&
                    selfindex)%twodarray(3, num_parameters))
                    do i = 1, 3
                        do j = 1, num_parameters
                            dforces_dparameters(&
                            selfindex)%twodarray(i, j) = 0.0d0
                        end do
                    end do
                end do
                ! calculates dforces_dparameters
                if (numericprime .EQV. .FALSE.) then
                    call calculate_dforces_dparameters(image_no)
                else
                    call calculate_numerical_dforces_dparameters(image_no)
                end if
                ! calculates contribution of forceloss to
                ! dloss_dparameters
                do j = 1, num_parameters
                    image_dldp(j) = 0.0d0
                end do
                if (nft == 1) then
                  f_index = nft_indices(image_no) + 1
                  do i = 1, 3
                      do j = 1, num_parameters
                          image_dldp(j) = image_dldp(j) + &
                          (amp_forces(f_index, i) - &
                          actual_forces_(f_index, i)) * &
                          dforces_dparameters(&
                          f_index)%twodarray(i, j)
                      end do
                  end do
                  do j = 1, num_parameters
                      image_dldp(j) = image_weight * &
                              image_dldp(j) * force_coefficient &
                              * 2.0d0 / 3.0d0
                      dloss_dparameters(j) = dloss_dparameters(j) + &
                      image_dldp(j)
                  end do
                else
                  do selfindex = 1, num_atoms
                      do i = 1, 3
                          do j = 1, num_parameters
                              image_dldp(j) = image_dldp(j) + &
                              (amp_forces(selfindex, i) - &
                              actual_forces_(selfindex, i)) * &
                              dforces_dparameters(&
                              selfindex)%twodarray(i, j)
                          end do
                      end do
                  end do
                  do j = 1, num_parameters
                      image_dldp(j) = image_weight * &
                              image_dldp(j) * force_coefficient &
                              * 2.0d0 / 3.0d0 / num_atoms
                      dloss_dparameters(j) = dloss_dparameters(j) + &
                      image_dldp(j)
                  end do
                end if
                do p = 1, size(dforces_dparameters)
                    deallocate(dforces_dparameters(p)%twodarray)
                end do
                deallocate(dforces_dparameters)
            end if
            deallocate(actual_forces_)
            deallocate(amp_forces)
        end if
      end do
      loss = energy_coefficient * energyloss + &
             force_coefficient * forceloss

      ! if overfit coefficient is more than zero, overfit
      ! contribution to loss and dloss_dparameters is also added.
      ! Do not regularize scaling parameters
      if (overfit .GT. 0.0d0) then
          overfitloss = 0.0d0
          do j = 1, num_parameters
              mask = overfit_mask(j)
              if (mask == 1) then
                overfitloss = overfitloss + &
                parameters(j) ** 2.0d0
              ! ABS(parameters(j))
              end if
          end do
          overfitloss = overfit * overfitloss
          loss = loss + overfitloss
          do j = 1, num_parameters
              mask = overfit_mask(j)
              if (mask == 1) then
                ! signofx = sgn(parameters(j))
                doverfitloss_dparameters(j) = &
                2.0d0 * overfit * parameters(j)
                ! overfit * signofx
                dloss_dparameters(j) = dloss_dparameters(j) + &
                doverfitloss_dparameters(j)
              end if
          end do
      end if

!     deallocations for all images
      if (mode_signal == 1) then
        do image_no = 1, num_images
            deallocate(unraveled_atomic_positions(image_no)%onedarray)
        end do
        deallocate(unraveled_atomic_positions)
        deallocate(inputs)
        deallocate(inputs_)
      else
        do image_no = 1, num_images
            deallocate(unraveled_atomic_numbers(image_no)%onedarray)
        end do
        deallocate(unraveled_atomic_numbers)
        do image_no = 1, num_images
            num_atoms = num_images_atoms(image_no)
            do index = 1, num_atoms
                deallocate(unraveled_fingerprints(&
                image_no)%onedarray(index)%onedarray)
            end do
            deallocate(unraveled_fingerprints(image_no)%onedarray)
        end do
        deallocate(unraveled_fingerprints)
      end if

      if (train_forces .EQV. .TRUE.) then
        do image_no = 1, num_images
            deallocate(unraveled_actual_forces(image_no)%atom_forces)
        end do
        deallocate(unraveled_actual_forces)
        if (mode_signal == 2) then
            do image_no = 1, num_images
                num_atoms = num_images_atoms(image_no)
                do selfindex = 1, num_atoms
                    do nindex = 1, &
                    size(unraveled_fingerprintprimes(&
                    image_no)%onedarray(selfindex)%onedarray)
                        deallocate(&
                        unraveled_fingerprintprimes(&
                        image_no)%onedarray(selfindex)%onedarray(&
                        nindex)%twodarray)
                    end do
                    deallocate(unraveled_fingerprintprimes(&
                    image_no)%onedarray(selfindex)%onedarray)
                end do
                deallocate(unraveled_fingerprintprimes(&
                image_no)%onedarray)
            end do
            deallocate(unraveled_fingerprintprimes)
            do image_no = 1, num_images
                num_atoms = num_images_atoms(image_no)
                do index = 1, num_atoms
                    deallocate(unraveled_neighborlists(&
                    image_no)%onedarray(index)%onedarray)
                end do
                deallocate(unraveled_neighborlists(image_no)%onedarray)
            end do
            deallocate(unraveled_neighborlists)
        end if
      end if


      contains

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      ! calculates amp_energy
      subroutine calculate_energy(image_no)

      if (mode_signal == 1) then
        amp_energy = &
        calculate_image_energy(num_inputs, inputs, num_parameters, &
        parameters)
      else
        amp_energy = 0.0d0
        do index = 1, num_atoms
            symbol = unraveled_atomic_numbers(&
            image_no)%onedarray(index)
            do element = 1, num_elements
                if (symbol == elements_numbers(element)) then
                    exit
                end if
            end do
            len_of_fingerprint = num_fingerprints_of_elements(element)
            allocate(fingerprint(len_of_fingerprint))
            do p = 1, len_of_fingerprint
                fingerprint(p) = &
                unraveled_fingerprints(&
                image_no)%onedarray(index)%onedarray(p)
            end do

            atom_energy = calculate_atomic_energy(symbol, &
            len_of_fingerprint, fingerprint, num_elements, &
            elements_numbers, num_parameters, parameters)
            deallocate(fingerprint)
            amp_energy = amp_energy + atom_energy
        end do
      end if

      end subroutine calculate_energy

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      ! calculates amp_forces
      subroutine calculate_forces(image_no)

      allocate(amp_forces(num_atoms, 3))
      do selfindex = 1, num_atoms
        do i = 1, 3
            amp_forces(selfindex, i) = 0.0d0
        end do
      end do
      nft = is_nft(image_no)
      f_index = nft_indices(image_no) + 1
      if (nft == 1) then
        ! neighborindices list is generated.
        allocate(neighborindices(size(&
        unraveled_neighborlists(image_no)%onedarray(&
        f_index)%onedarray)))
        do p = 1, size(unraveled_neighborlists(&
        image_no)%onedarray(f_index)%onedarray)
            neighborindices(p) = unraveled_neighborlists(&
            image_no)%onedarray(f_index)%onedarray(p)
        end do

        do l = 1, size(neighborindices)
            nindex = neighborindices(l)
            nsymbol = unraveled_atomic_numbers(&
                      image_no)%onedarray(nindex)
            do element = 1, num_elements
                if (nsymbol == elements_numbers(element)) then
                    exit
                end if
            end do
            len_of_fingerprint = &
            num_fingerprints_of_elements(element)
            allocate(fingerprint(len_of_fingerprint))
            do p = 1, len_of_fingerprint
                fingerprint(p) = unraveled_fingerprints(&
                image_no)%onedarray(nindex)%onedarray(p)
            end do

            do i = 1, 3
                allocate(fingerprintprime(len_of_fingerprint))
                do p = 1, len_of_fingerprint
                    fingerprintprime(p) = &
                    unraveled_fingerprintprimes(&
                    image_no)%onedarray(&
                    f_index)%onedarray(l)%twodarray(i, p)
                end do
                dforce = calculate_force(nsymbol, len_of_fingerprint, &
                        fingerprint, fingerprintprime, &
                        num_elements, elements_numbers, &
                        num_parameters, parameters)
                amp_forces(f_index, i) = &
                amp_forces(f_index, i) + dforce
                deallocate(fingerprintprime)
            end do
            deallocate(fingerprint)
        end do
        deallocate(neighborindices)
      else
        do selfindex = 1, num_atoms
          if (mode_signal == 1) then
              do i = 1, 3
                  do p = 1,  3 * num_atoms
                      inputs_(p) = 0.0d0
                  end do
                  inputs_(3 * (selfindex - 1) + i) = 1.0d0
                  amp_forces(selfindex, i) = calculate_force_(num_inputs, &
                  inputs, inputs_, num_parameters, parameters)
              end do
          else
              ! neighborindices list is generated.
              allocate(neighborindices(size(&
              unraveled_neighborlists(image_no)%onedarray(&
              selfindex)%onedarray)))
              do p = 1, size(unraveled_neighborlists(&
              image_no)%onedarray(selfindex)%onedarray)
                  neighborindices(p) = unraveled_neighborlists(&
                  image_no)%onedarray(selfindex)%onedarray(p)
              end do

              do l = 1, size(neighborindices)
                  nindex = neighborindices(l)
                  nsymbol = unraveled_atomic_numbers(&
                            image_no)%onedarray(nindex)
                  do element = 1, num_elements
                      if (nsymbol == elements_numbers(element)) then
                          exit
                      end if
                  end do
                  len_of_fingerprint = &
                  num_fingerprints_of_elements(element)
                  allocate(fingerprint(len_of_fingerprint))
                  do p = 1, len_of_fingerprint
                      fingerprint(p) = unraveled_fingerprints(&
                      image_no)%onedarray(nindex)%onedarray(p)
                  end do

                  do i = 1, 3
                      allocate(fingerprintprime(len_of_fingerprint))
                      do p = 1, len_of_fingerprint
                          fingerprintprime(p) = &
                          unraveled_fingerprintprimes(&
                          image_no)%onedarray(&
                          selfindex)%onedarray(l)%twodarray(i, p)
                      end do
                      dforce = calculate_force(nsymbol, len_of_fingerprint, &
                              fingerprint, fingerprintprime, &
                              num_elements, elements_numbers, &
                              num_parameters, parameters)
                      amp_forces(selfindex, i) = &
                      amp_forces(selfindex, i) + dforce
                      deallocate(fingerprintprime)
                  end do
                  deallocate(fingerprint)
              end do
              deallocate(neighborindices)
          end if
        end do
      end if

      end subroutine calculate_forces

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      ! calculates analytical denergy_dparameters in
      ! the atom-centered mode.
      subroutine calculate_denergy_dparameters(image_no)

      do index = 1, num_atoms
          symbol = unraveled_atomic_numbers(image_no)%onedarray(index)
          do element = 1, num_elements
              if (symbol == elements_numbers(element)) then
                  exit
              end if
          end do
          len_of_fingerprint = num_fingerprints_of_elements(element)
          allocate(fingerprint(len_of_fingerprint))
          do p = 1, len_of_fingerprint
              fingerprint(p) = unraveled_fingerprints(&
              image_no)%onedarray(index)%onedarray(p)
          end do
          daenergy_dparameters = calculate_datomicenergy_dparameters(&
          symbol, len_of_fingerprint, fingerprint, &
          num_elements, elements_numbers, num_parameters, parameters)
          deallocate(fingerprint)
          do j = 1, num_parameters
             denergy_dparameters(j) = denergy_dparameters(j) + &
             daenergy_dparameters(j)
          end do
      end do

      end subroutine calculate_denergy_dparameters

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      ! calculates numerical denergy_dparameters in the
      ! atom-centered mode.
      subroutine calculate_numerical_denergy_dparameters(image_no)

      double precision:: eplus, eminus

      do j = 1, num_parameters
          parameters(j) = parameters(j) + d
          call calculate_energy(image_no)
          eplus = amp_energy
          parameters(j) = parameters(j) - 2.0d0 * d
          call calculate_energy(image_no)
          eminus = amp_energy
          denergy_dparameters(j) = (eplus - eminus) / (2.0d0 * d)
          parameters(j) = parameters(j) + d
      end do
      call calculate_energy(image_no)

      end subroutine calculate_numerical_denergy_dparameters

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      ! calculates dforces_dparameters.
      subroutine calculate_dforces_dparameters(image_no)

      if (mode_signal == 1) then ! image-centered mode
          do selfindex = 1, num_atoms
              do i = 1, 3
                do p = 1,  3 * num_atoms
                    inputs_(p) = 0.0d0
                end do
                inputs_(3 * (selfindex - 1) + i) = 1.0d0
                dforce_dparameters = calculate_dforce_dparameters_(&
                num_inputs, inputs, inputs_, num_parameters, parameters)
                do j = 1, num_parameters
                    dforces_dparameters(selfindex)%twodarray(i, j) = &
                    dforce_dparameters(j)
                end do
              end do
          end do

      nft = is_nft(image_no)
      f_index = nft_indices(image_no) + 1
      else ! atom-centered mode
        if (nft == 1) then
            ! neighborindices list is generated.
            allocate(neighborindices(size(&
            unraveled_neighborlists(image_no)%onedarray(&
            f_index)%onedarray)))
            do p = 1, size(unraveled_neighborlists(&
            image_no)%onedarray(f_index)%onedarray)
                neighborindices(p) = unraveled_neighborlists(&
                image_no)%onedarray(f_index)%onedarray(p)
            end do
            do l = 1, size(neighborindices)
                nindex = neighborindices(l)
                nsymbol = unraveled_atomic_numbers(&
                image_no)%onedarray(nindex)
                do element = 1, num_elements
                    if (nsymbol == elements_numbers(element)) then
                      exit
                    end if
                end do
                len_of_fingerprint = &
                num_fingerprints_of_elements(element)
                allocate(fingerprint(len_of_fingerprint))
                do p = 1, len_of_fingerprint
                    fingerprint(p) = unraveled_fingerprints(&
                    image_no)%onedarray(nindex)%onedarray(p)
                end do
                do i = 1, 3
                    allocate(fingerprintprime(len_of_fingerprint))
                    do p = 1, len_of_fingerprint
                        fingerprintprime(p) = &
                        unraveled_fingerprintprimes(&
                        image_no)%onedarray(f_index)%onedarray(&
                        l)%twodarray(i, p)
                    end do
                    dforce_dparameters = calculate_dforce_dparameters(&
                    nsymbol, len_of_fingerprint, fingerprint, &
                    fingerprintprime, num_elements, &
                    elements_numbers, num_parameters, parameters)
                    deallocate(fingerprintprime)
                    do j = 1, num_parameters
                        dforces_dparameters(&
                        f_index)%twodarray(i, j) = &
                        dforces_dparameters(&
                        f_index)%twodarray(i, j) + &
                        dforce_dparameters(j)
                    end do
                end do
                deallocate(fingerprint)
            end do
            deallocate(neighborindices)
        else
          do selfindex = 1, num_atoms
            ! neighborindices list is generated.
            allocate(neighborindices(size(&
            unraveled_neighborlists(image_no)%onedarray(&
            selfindex)%onedarray)))
            do p = 1, size(unraveled_neighborlists(&
            image_no)%onedarray(selfindex)%onedarray)
                neighborindices(p) = unraveled_neighborlists(&
                image_no)%onedarray(selfindex)%onedarray(p)
            end do
            do l = 1, size(neighborindices)
                nindex = neighborindices(l)
                nsymbol = unraveled_atomic_numbers(&
                image_no)%onedarray(nindex)
                do element = 1, num_elements
                    if (nsymbol == elements_numbers(element)) then
                      exit
                    end if
                end do
                len_of_fingerprint = &
                num_fingerprints_of_elements(element)
                allocate(fingerprint(len_of_fingerprint))
                do p = 1, len_of_fingerprint
                    fingerprint(p) = unraveled_fingerprints(&
                    image_no)%onedarray(nindex)%onedarray(p)
                end do
                do i = 1, 3
                    allocate(fingerprintprime(len_of_fingerprint))
                    do p = 1, len_of_fingerprint
                        fingerprintprime(p) = &
                        unraveled_fingerprintprimes(&
                        image_no)%onedarray(selfindex)%onedarray(&
                        l)%twodarray(i, p)
                    end do
                    dforce_dparameters = calculate_dforce_dparameters(&
                    nsymbol, len_of_fingerprint, fingerprint, &
                    fingerprintprime, num_elements, &
                    elements_numbers, num_parameters, parameters)
                    deallocate(fingerprintprime)
                    do j = 1, num_parameters
                        dforces_dparameters(&
                        selfindex)%twodarray(i, j) = &
                        dforces_dparameters(&
                        selfindex)%twodarray(i, j) + &
                        dforce_dparameters(j)
                    end do
                end do
                deallocate(fingerprint)
            end do
            deallocate(neighborindices)
          end do
        end if
      end if

      end subroutine calculate_dforces_dparameters

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      ! calculates numerical dforces_dparameters in the
      ! atom-centered mode.
      subroutine calculate_numerical_dforces_dparameters(image_no)

      double precision, allocatable:: fplus(:, :), fminus(:, :)

      do j = 1, num_parameters
          parameters(j) = parameters(j) + d
          deallocate(amp_forces)
          call calculate_forces(image_no)
                allocate(fplus(num_atoms, 3))
                do selfindex = 1, num_atoms
                    do i = 1, 3
                        fplus(selfindex, i) = amp_forces(selfindex, i)
                    end do
                end do
          parameters(j) = parameters(j) - 2.0d0 * d
          deallocate(amp_forces)
          call calculate_forces(image_no)
                allocate(fminus(num_atoms, 3))
                do selfindex = 1, num_atoms
                    do i = 1, 3
                        fminus(selfindex, i) = amp_forces(selfindex, i)
                    end do
                end do
          do selfindex = 1, num_atoms
              do i = 1, 3
                  dforces_dparameters(selfindex)%twodarray(i, j) = &
                  (fplus(selfindex, i) - fminus(selfindex, i)) / &
                  (2.0d0 * d)
              end do
          end do
          parameters(j) = parameters(j) + d
          deallocate(fplus)
          deallocate(fminus)
      end do
      deallocate(amp_forces)
      call calculate_forces(image_no)

      end subroutine calculate_numerical_dforces_dparameters

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!     used only in the image-centered mode.
      subroutine unravel_atomic_positions()

      do image_no = 1, num_images
        allocate(unraveled_atomic_positions(image_no)%onedarray(&
        3 * num_atoms))
        do index = 1, num_atoms
            do i = 1, 3
                unraveled_atomic_positions(image_no)%onedarray(&
                3 * (index - 1) + i) = atomic_positions(&
                image_no, 3 * (index - 1) + i)
             end do
        end do
      end do

      end subroutine unravel_atomic_positions

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine unravel_atomic_numbers()

      k = 0
      do image_no = 1, num_images
        num_atoms = num_images_atoms(image_no)
        allocate(unraveled_atomic_numbers(&
        image_no)%onedarray(num_atoms))
        do l = 1, num_atoms
            unraveled_atomic_numbers(image_no)%onedarray(l) &
            = atomic_numbers(k + l)
        end do
        k = k + num_atoms
      end do

      end subroutine unravel_atomic_numbers

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine unravel_neighborlists()

      k = 0
      q = 0
      do image_no = 1, num_images
        num_atoms = num_images_atoms(image_no)
        allocate(unraveled_neighborlists(image_no)%onedarray(&
        num_atoms))
        do index = 1, num_atoms
            allocate(unraveled_neighborlists(image_no)%onedarray(&
            index)%onedarray(num_neighbors(k + index)))
            do p = 1, num_neighbors(k + index)
                unraveled_neighborlists(image_no)%onedarray(&
                index)%onedarray(p) = raveled_neighborlists(q + p)+1
            end do
            q = q + num_neighbors(k + index)
        end do
        k = k + num_atoms
      end do

      end subroutine unravel_neighborlists

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine unravel_actual_forces()

      k = 0
      do image_no = 1, num_images
        if (mode_signal == 1) then
            num_atoms = num_atoms
        else
            num_atoms = num_images_atoms(image_no)
        end if
        allocate(unraveled_actual_forces(image_no)%atom_forces(&
        num_atoms, 3))
        do index = 1, num_atoms
            do i = 1, 3
                unraveled_actual_forces(image_no)%atom_forces(&
                index, i) = actual_forces(k + index, i)
            end do
        end do
        k = k + num_atoms
      end do

      end subroutine unravel_actual_forces

 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine unravel_fingerprints()

      k = 0
      do image_no = 1, num_images
        num_atoms = &
        num_images_atoms(image_no)
        allocate(unraveled_fingerprints(&
        image_no)%onedarray(num_atoms))
        do index = 1, num_atoms
            do element = 1, num_elements
                if (unraveled_atomic_numbers(&
                image_no)%onedarray(index)== &
                elements_numbers(element)) then
                    allocate(unraveled_fingerprints(&
                    image_no)%onedarray(index)%onedarray(&
                    num_fingerprints_of_elements(element)))
                    exit
                end if
            end do
            do l = 1, num_fingerprints_of_elements(element)
                unraveled_fingerprints(&
                image_no)%onedarray(index)%onedarray(l) = &
                raveled_fingerprints(k + index, l)
            end do
        end do
      k = k + num_atoms
      end do

      end subroutine unravel_fingerprints

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine unravel_fingerprintprimes()

      integer:: no_of_neighbors

      k = 0
      m = 0
      do image_no = 1, num_images
        num_atoms = &
        num_images_atoms(image_no)
        allocate(unraveled_fingerprintprimes(&
        image_no)%onedarray(num_atoms))
        do selfindex = 1, num_atoms
        ! neighborindices list is generated.
            allocate(neighborindices(size(unraveled_neighborlists(&
            image_no)%onedarray(selfindex)%onedarray)))
            do p = 1, size(unraveled_neighborlists(&
            image_no)%onedarray(selfindex)%onedarray)
                neighborindices(p) = unraveled_neighborlists(&
                image_no)%onedarray(selfindex)%onedarray(p)
            end do
            no_of_neighbors = num_neighbors(k + selfindex)
            allocate(unraveled_fingerprintprimes(&
            image_no)%onedarray(selfindex)%onedarray(no_of_neighbors))
            do nindex = 1, no_of_neighbors
                do nsymbol = 1, num_elements
                if (unraveled_atomic_numbers(&
                image_no)%onedarray(neighborindices(nindex)) == &
                elements_numbers(nsymbol)) then
                    exit
                end if
                end do
                allocate(unraveled_fingerprintprimes(&
                image_no)%onedarray(selfindex)%onedarray(&
                nindex)%twodarray(3, num_fingerprints_of_elements(&
                nsymbol)))
                do p = 1, 3
                    do q = 1, num_fingerprints_of_elements(nsymbol)
                        unraveled_fingerprintprimes(&
                        image_no)%onedarray(selfindex)%onedarray(&
                        nindex)%twodarray(p, q) = &
                        raveled_fingerprintprimes(&
                        3 * m + 3 * nindex + p - 3, q)
                    end do
                end do
            end do
            deallocate(neighborindices)
            m = m + no_of_neighbors
        end do
        k = k + num_atoms
      end do

      end subroutine unravel_fingerprintprimes

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      end subroutine calculate_loss

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!     subroutine that deallocates variables
      subroutine deallocate_variables()

      use images_props
      use fingerprint_props
      use model_props
      use neuralnetwork

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!     deallocating fingerprint_props
      if (allocated(num_fingerprints_of_elements) .EQV. .TRUE.) then
        deallocate(num_fingerprints_of_elements)
      end if
      if (allocated(raveled_fingerprints) .EQV. .TRUE.) then
        deallocate(raveled_fingerprints)
      end if
      if (allocated(raveled_fingerprintprimes) .EQV. .TRUE.) then
        deallocate(raveled_fingerprintprimes)
      end if

!     deallocating images_props
      if (allocated(elements_numbers) .EQV. .TRUE.) then
        deallocate(elements_numbers)
      end if
      if (allocated(num_images_atoms) .EQV. .TRUE.) then
        deallocate(num_images_atoms)
      end if
      if (allocated(atomic_numbers) .EQV. .TRUE.) then
        deallocate(atomic_numbers)
      end if
      if (allocated(num_neighbors) .EQV. .TRUE.) then
        deallocate(num_neighbors)
      end if
      if (allocated(raveled_neighborlists) .EQV. .TRUE.) then
        deallocate(raveled_neighborlists)
      end if
      if (allocated(actual_energies) .EQV. .TRUE.) then
        deallocate(actual_energies)
      end if
      if (allocated(image_weights) .EQV. .TRUE.) then
        deallocate(image_weights)
      end if
      if (allocated(actual_forces) .EQV. .TRUE.) then
        deallocate(actual_forces)
      end if
      if (allocated(atomic_positions) .EQV. .TRUE.) then
        deallocate(atomic_positions)
      end if

!     deallocating neuralnetwork
      if (allocated(min_fingerprints) .EQV. .TRUE.) then
        deallocate(min_fingerprints)
      end if
      if (allocated(max_fingerprints) .EQV. .TRUE.) then
        deallocate(max_fingerprints)
      end if
      if (allocated(no_layers_of_elements) .EQV. .TRUE.) then
        deallocate(no_layers_of_elements)
      end if
      if (allocated(no_nodes_of_elements) .EQV. .TRUE.) then
        deallocate(no_nodes_of_elements)
      end if

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      end subroutine deallocate_variables

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
